#include <SDL/SDL_events.h>
#include <SDL/SDL_keysym.h>
#include "events.h"

int have_mouse_focus=1;

int events_loop()
{
  SDL_Event event;
  SDLMod mod_key_status;
  int i;

  //while (1)
  {
	int poll_result;


	poll_result=SDL_PollEvent(&event);
	if(!poll_result)return 0;
	//SDL_WaitEvent (&event);

	if(event.type == SDL_QUIT)return 1;
	//break;

	mod_key_status=SDL_GetModState();
	if(mod_key_status&KMOD_CAPS)caps_lock_on=1;
	else caps_lock_on=0;

	if(mod_key_status&KMOD_LCTRL || mod_key_status&KMOD_RCTRL)ctrl_on=1;
	else ctrl_on=0;

	if(mod_key_status&KMOD_LALT || mod_key_status&KMOD_RALT)alt_on=1;
	else alt_on=0;

	if(mod_key_status&KMOD_RSHIFT || mod_key_status&KMOD_LSHIFT)shift_on=1;
	else
		{
			if(shift_on==1)update_screen=1;
			shift_on=0;
		}


	if(event.type == SDL_ACTIVEEVENT)
	if(event.active.state & SDL_APPINPUTFOCUS)
		{
			long_pressed_button_l = 0;
			long_pressed_button_r = 0;

			//still have mouse focus?
			if(!event.active.gain)
				{
					have_mouse_focus=0;
				}
			else
			have_mouse_focus=1;
		}

	if(have_mouse_focus)
    if(event.type == SDL_MOUSEBUTTONUP)
    {
		while (SDL_PollEvent (&event));	//clears all the events
		update_screen=1;

		//mark buttons as unpressed at all, so they are fresh.
		long_pressed_button_l = 0;
		long_pressed_button_r = 0;
		if(SDL_GetMouseState (NULL, NULL) & SDL_BUTTON (SDL_BUTTON_LEFT))
		button_l = 1;
		else
		button_l = 0;

		if(SDL_GetMouseState (NULL, NULL) & SDL_BUTTON (SDL_BUTTON_RIGHT))
		button_r = 1;
		else
		button_r = 0;

    }

	if(have_mouse_focus)
	if(event.type == SDL_MOUSEMOTION || event.type == SDL_MOUSEBUTTONDOWN || event.type == SDL_MOUSEBUTTONUP)
		{
			x_mouse_pos = event.motion.x;
			y_mouse_pos = event.motion.y;
			mouse_delta_x = event.motion.xrel;
			mouse_delta_y = event.motion.yrel;

			if(event.type == SDL_MOUSEBUTTONDOWN || event.type == SDL_MOUSEBUTTONUP || button_l || button_r)
			update_screen=1;

			mouse_over(x_mouse_pos, y_mouse_pos);

			//get the buttons state
			if((SDL_GetMouseState(NULL, NULL) & SDL_BUTTON (SDL_BUTTON_LEFT)))
				{
					button_l = 1;
					long_pressed_button_l++;
					if(event.type == SDL_MOUSEBUTTONDOWN && button_l)
						{
							last_left_click_time=this_left_click_time;
							this_left_click_time=SDL_GetTicks();
						}
				}
			else
			button_l = 0;
			if(SDL_GetMouseState(NULL, NULL) & SDL_BUTTON (SDL_BUTTON_RIGHT))
				{
					button_r = 1;
					long_pressed_button_r++;
				}
			else
			button_r = 0;

      	//if(button_l || button_r)
      	mouse_click(button_l, button_r, x_mouse_pos, y_mouse_pos);

		}


		if(event.type == SDL_VIDEORESIZE)
			{
				update_screen=1;

				window_width = event.resize.w;
				window_height = event.resize.h;

				if(window_width < 800)window_width = 800;
				if(window_height < 550)window_height = 550;

				window_width=window_width|3;
				screen = SDL_SetVideoMode (window_width, window_height,8,SDL_HWSURFACE | SDL_RESIZABLE | SDL_HWPALETTE);
				SDL_SetPalette (screen, SDL_LOGPAL | SDL_PHYSPAL, colors, 0, 256);

				init_menus();

			}

		if(event.type == SDL_MOUSEBUTTONDOWN)
			{
				if(event.button.button == SDL_BUTTON_WHEELUP)
					{

					}

				else if(event.button.button == SDL_BUTTON_WHEELDOWN)
					{

					}
			}

		if(event.type==SDL_KEYDOWN)
		{
			Uint8 *keystate = SDL_GetKeyState(NULL);
			char ch=event.key.keysym.unicode & 0x7F;

			update_screen=1;

			//if(!process_keyboard_menus(event.key.keysym.sym))
			if(!process_keyboard_menus(ch))
				{

					if(keystate[SDLK_RETURN])
						{
							activate_cur_file();
						}

					if(keystate[SDLK_DOWN])
						{
							move_cursor_down();
						}

					if(keystate[SDLK_UP])
						{
							move_cursor_up();
						}

					if(keystate[SDLK_RIGHT])
						{
							move_cursor_right();
						}

					if(keystate[SDLK_LEFT])
						{
							move_cursor_left();
						}

					if(keystate[SDLK_PAGEDOWN])
						{

						}

					if(keystate[SDLK_PAGEUP])
						{

						}

					if(keystate[SDLK_HOME])
						{
							move_cursor_home();
						}

					if(keystate[SDLK_END])
						{
							move_cursor_end();
						}

					if(keystate[SDLK_TAB])
						{
							switch_panels();
						}

					if(keystate[SDLK_KP_MULTIPLY])
						{
							select_all();
						}

					if(keystate[SDLK_INSERT])
						{
							select_cur_file();
						}

					if(keystate[SDLK_KP_PLUS])
						{
							select_deselect_file_by_extension(1,ctrl_on);
						}

					if(keystate[SDLK_KP_MINUS])
						{
							select_deselect_file_by_extension(0,ctrl_on);
						}

					if(keystate[SDLK_r])
						{
							if(ctrl_on)
								{
									panels[active_panel].needs_reread=1;
								}
						}

					if(keystate[SDLK_F1])
						{
							if(alt_on)
								{
									active_panel=0;
									open_bookmarks_menu();
								}
						}

					if(keystate[SDLK_F2])
						{
							if(alt_on)
								{
									active_panel=1;
									open_bookmarks_menu();
								}
						}

					if(keystate[SDLK_F3])
						{
							if(shift_on)
							hex_view_file();
							else
							view_file();
						}

					if(keystate[SDLK_F4])
						{
							edit_file();
						}

					if(keystate[SDLK_F5])
						{
							activate_copy_menu();
						}


					if(keystate[SDLK_F6])
						{
							activate_move_menu();
						}


					if(keystate[SDLK_F7])
						{
							activate_mkdir_menu();
						}

					if(keystate[SDLK_F8])
						{
							activate_delete_menu();
						}

					if(keystate[SDLK_F9])
						{
							activate_config_menu();
						}


				}

		}

	}
	return 0;

}

void mouse_over(int mouse_x, int mouse_y)
{
	if(mouse_over_menus(mouse_x, mouse_y))
		{
			//menus must do their own screen update if necessary
			return;
		}

}

void mouse_click(int left_b, int right_b, int mouse_x, int mouse_y)
{
	if(click_menus(left_b, right_b, mouse_x, mouse_y))return;

	if(left_b || right_b)
		{
			menus[sort_menu_id].opened=0;
			menus[bookmarks_menu_id].opened=0;
		}

	if(click_on_panel(left_b, right_b, mouse_x, mouse_y))return;
	if(check_main_buttons(left_b, right_b, mouse_x, mouse_y))return;

	//if(click_menus(left_b, right_b, mouse_x, mouse_y))return;

}

