#include "global.h"
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

int move_instead_of_copy=0;

char source_copy_text[MAX_PATH];
char dest_copy_text[MAX_PATH];

char current_copying_file[MAX_PATH];
char current_copying_file_dest[MAX_PATH];

char current_deleting_file[MAX_PATH];

int files_to_be_copied;
int files_copied;
int abort_copy;
int time_copy_started;
int time_copy_paused;
int cancel_copy;
int cancel_delete;
unsigned long long int files_to_be_copied_size;
unsigned long long int files_copied_size;
unsigned long long int this_file_copying_size;
unsigned long long int this_file_copied_size;

unsigned long long int files_copied_until_now_size;

char overwrite_source_date[128];
char overwrite_dest_date[128];
char overwrite_source_size[64];
char overwrite_dest_size[64];

int overwrite_decision=OVERWRITE_FILE_PENDING;
int error_decision=ERROR_DECISSION_OK;

char error_text[128];
char aux_error_text[128];

int does_dir_exist(char *path)
{
	DIR *dp_test;

	dp_test = opendir(path);
	if(dp_test)
		{
			return 1;
			closedir(dp_test);
		}

	return 0;
}

unsigned long long int get_disk_space(char *path)
{
	unsigned long long int free_space;

#ifdef WINDOWS
	GetDiskFreeSpaceEx(path,&free_space,NULL,NULL);
	return free_space;
#else
	struct statvfs buf;
	statvfs(path, &buf);
	free_space=buf.f_bsize;
	free_space*=buf.f_bavail;
#endif
}

void get_dir_size(char *cur_dir)
{
	DIR *dp;
	struct dirent *ep;
	int file_attributes;
	//struct stat buf;
#ifndef WINDOWS
	struct stat64 buf;
#else
	struct _stati64 buf;
#endif
	int is_dir=0;
	int is_link=0;
	char full_path_string[MAX_PATH];

	update_screen=1;
	if(cancel_copy)return;

	dp = opendir (cur_dir);
	if(dp != NULL)
	{
	 	while(ep = readdir(dp))
	 		{
				//remove the "." entry
				if(ep->d_name[0]=='.' && ep->d_name[1]==0)continue;
				if(ep->d_name[0]=='.' && ep->d_name[1]=='.' && ep->d_name[2]==0)continue;

				strcpy(full_path_string,cur_dir);
				strcat(full_path_string,"/");
				strcat(full_path_string,ep->d_name);

//windows doesn't have the d_type field
#ifndef WINDOWS
				if(ep->d_type==DT_DIR)is_dir=1;
				else is_dir=0;
				if(ep->d_type==DT_LNK)is_link=1;
				else is_link=0;


#else

				file_attributes=GetFileAttributes(full_path_string);
				if(file_attributes & FILE_ATTRIBUTE_DIRECTORY)is_dir=1;
				else is_dir=0;
#endif

#ifndef WINDOWS
				if(is_link)
				{
					//nothing, links have no size, we also don't follow them
				}
				else
#endif
				if(is_dir)
					{
						get_dir_size(full_path_string);
					}
				else
					{
						//stat(full_path_string, &buf);
#ifndef WINDOWS
						stat64(ep->d_name, &buf);
#else
						_stati64(ep->d_name, &buf);
#endif
						files_size+=buf.st_size;
					}
			}

	 	(void)closedir(dp);
	}

}

void pre_get_dir_size(char *cur_dir)
{
	menus[calculating_size_menu_id].opened=1;
	update_screen=1;
	get_dir_size(cur_dir);
	menus[calculating_size_menu_id].opened=0;
	update_screen=1;
}


int file_exists_ask_overwrite(char *source,char *dest,int is_link)
{
	struct stat buf;
	int result;

	stat(source, &buf);
	format_date(buf.st_mtime,overwrite_source_date,date_format);
	format_number(buf.st_size,overwrite_source_size,(decimal_separator) ? '.':',');

	stat(dest, &buf);
	format_date(buf.st_mtime,overwrite_dest_date,date_format);
	format_number(buf.st_size,overwrite_dest_size,(decimal_separator) ? '.':',');

	if(overwrite_decision!=OVERWRITE_FILE_OVERWRITE_ALL && overwrite_decision!=OVERWRITE_FILE_SKIP_ALL)
		{
			menus[overwrite_menu_id].opened=1;
			update_screen=1;
			strcpy(current_copying_file_dest,dest);
			overwrite_selected_button=0;
		}

	while(overwrite_decision==OVERWRITE_FILE_PENDING)
#ifdef WINDOWS
			Sleep(5);
#else
        	usleep(5000);
#endif

		//user pressed some button
	if(overwrite_decision==OVERWRITE_FILE_OVERWRITE_THIS || overwrite_decision==OVERWRITE_FILE_OVERWRITE_ALL)
		{
			if(overwrite_decision==OVERWRITE_FILE_OVERWRITE_THIS)
			overwrite_decision=OVERWRITE_FILE_PENDING;
#ifdef WINDOWS
			SetFileAttributes(dest,FILE_ATTRIBUTE_NORMAL);
			DeleteFile(dest);
#else

			chmod(dest, S_IWRITE);
			result=unlink(dest);
			if(result==-1)return 0;//fuck it, couldn't delete this shit :/
#endif
		}

	if(overwrite_decision==OVERWRITE_FILE_SKIP_THIS)
		{
			overwrite_decision=OVERWRITE_FILE_PENDING;
			return 0;
		}

	if(overwrite_decision==OVERWRITE_FILE_SKIP_ALL || overwrite_decision==OVERWRITE_FILE_CANCEL)
		{
			return 0;
		}

	return 1;
}

#ifdef WINDOWS
DWORD CALLBACK progress_callback(LARGE_INTEGER total_size,LARGE_INTEGER total_transfered,LARGE_INTEGER stream_size,LARGE_INTEGER stream_transfered,DWORD stream_number,DWORD reason,HANDLE source_handle,HANDLE dest_handle,LPVOID lpData);

DWORD CALLBACK progress_callback(LARGE_INTEGER total_size,LARGE_INTEGER total_transfered,LARGE_INTEGER stream_size,LARGE_INTEGER stream_transfered,DWORD stream_number,DWORD reason,HANDLE source_handle,HANDLE dest_handle,LPVOID lpData)
{
	update_screen=1;
	this_file_copied_size=total_transfered.QuadPart;
	files_copied_size=files_copied_until_now_size+total_transfered.QuadPart;
	return PROGRESS_CONTINUE;
}
#endif

#ifndef WINDOWS
int copy_unix_file(char *source,char *dest)
{
	struct stat buf;
	struct utimbuf ut;

	char bufffer[8192];
	int in_fd;
	int out_fd;


	in_fd = open(source, O_RDONLY);
	if(in_fd==-1)return 0;
	posix_fadvise(in_fd, 0, 0, POSIX_FADV_SEQUENTIAL);
	fstat(in_fd, &buf);

	out_fd = open(dest, O_WRONLY|O_CREAT);
	if(out_fd==-1)
		{
			close(in_fd);
			return 0;
		}

	while(1)
		{
    		size_t result;
    		result=read(in_fd, bufffer, sizeof(bufffer));
    		if(!result)break;
    		if(result==-1)
    			{
					close(in_fd);
					close(out_fd);
					unlink(dest);
    				return 0;
				}

    		result=write(out_fd, bufffer, result);
    		if(result==-1)
    			{
					close(in_fd);
					close(out_fd);
					unlink(dest);
    				return 0;
				}
			this_file_copied_size+=result;
			files_copied_size=files_copied_until_now_size+result;

			if(cancel_copy)
    			{
					close(in_fd);
					close(out_fd);
					unlink(dest);
    				return 0;
				}
		}

	close(in_fd);
	close(out_fd);

	chmod(dest, buf.st_mode);

	//set the time
	ut.actime=buf.st_atime;
	ut.modtime=buf.st_mtime;
	utime(dest, &ut);

	return 1;
}

int copy_link(char *dest, char *source)
{
	char buf[FILENAME_MAX];
	int link_len;
	int ret_value;
	struct stat st;

	strcpy(current_copying_file,source);
	this_file_copying_size=0;
	this_file_copied_size=0;

	if(stat(dest,&st)==0)
	if(!file_exists_ask_overwrite(source,dest,1))return 0;

	link_len=readlink(source,buf,FILENAME_MAX);
	if(link_len!=-1)
		{
			buf[link_len]=0;
			ret_value=symlink(buf, dest);
		}

	if(ret_value==-1 && error_decision!=ERROR_DECISSION_IGNORE)
	{
		char str[200];
		format_errno_error(str);
		set_error(str, dest);

		while(error_decision==ERROR_DECISSION_PENDING)
		usleep(5);
	}

	if(ret_value==-1)return 0;

	update_screen=1;
	files_copied++;

	return 1;
}

int copy_special_file(char *dest, char *source, int is_special)
{
	struct stat st;
	int ret_value;
	struct utimbuf ut;

	stat(source,&st);

	ret_value=mknod(dest, st.st_mode, st.st_rdev);
	if(!ret_value)
		{
			//set the time
			ut.actime=st.st_atime;
			ut.modtime=st.st_mtime;
			utime(dest, &ut);
			return 1;
		}
	else return 0;
}

#endif

int copy_single_file(char *dest, char *source, unsigned long long int file_size, int is_special)
{
	int result;
	int file_exists;
	struct stat st;

	strcpy(current_copying_file,source);
	this_file_copying_size=file_size;
	this_file_copied_size=0;

	//does the file exist?
	if(stat(dest,&st)==0)
  	if(!file_exists_ask_overwrite(source,dest,0))return 0;

#ifdef WINDOWS
	result=CopyFileEx(source,dest,progress_callback,NULL,&cancel_copy,COPY_FILE_FAIL_IF_EXISTS);
	if(!result && error_decision!=ERROR_DECISSION_IGNORE)
		{
			result=GetLastError();
			if(result==1235)strcpy(error_text,"Request aborted.");
			else
			if(result==21)strcpy(error_text,"Device not ready.");
			else
			if(result==3)strcpy(error_text,"The system cannot find the path specified.");
			else
			if(result==5)strcpy(error_text,"Access denied.");
			else
			if(result==32)strcpy(error_text,"File in use.");
			else
			sprintf(error_text,"Error code %i",result);

			set_error(error_text, dest);
			while(error_decision==ERROR_DECISSION_PENDING)
			Sleep(5);

			return 0;
		}
#else
		if(is_special)
		result=copy_special_file(dest,source,is_special);
		else
		result=copy_unix_file(source,dest);

		if(!result && error_decision!=ERROR_DECISSION_IGNORE)
		{
			char str[200];
			format_errno_error(str);
			set_error(str, dest);

			while(error_decision==ERROR_DECISSION_PENDING)
			usleep(5);

			return 0;
		}
#endif


	update_screen=1;
	files_copied++;
	files_copied_until_now_size+=file_size;

	return 1;
}

void prepare_to_copy_single_file(int file_pos,int preserve_path)
{
	char source_fn[MAX_PATH];
	char dest_fn[MAX_PATH];
	char *file_name;
	//set up stuff
	//cancel_copy=0;

	file_name=panels[active_panel].panel_files[file_pos].name;
	strcpy(source_fn,panels[active_panel].dir_path);
	strcat(source_fn,"/");
	strcat(source_fn,file_name);

	strcpy(dest_fn,dest_copy_text);
	if(!preserve_path)
		{
			//strcat(dest_fn,"/");
			strcat(dest_fn,file_name);
		}

#ifndef WINDOWS
	if(panels[active_panel].panel_files[file_pos].is_link)
		{
			copy_link(dest_fn, source_fn);
			return;
		}
#endif

	if(panels[active_panel].panel_files[file_pos].is_dir)
	copy_dir(dest_fn, source_fn);
	else
	copy_single_file(dest_fn, source_fn,panels[active_panel].panel_files[file_pos].st_size,panels[active_panel].panel_files[file_pos].is_special);
}

int is_dir_recursive(char *dest, char *source)
{
	int i=0;
	int j=0;
	int len;
	char s;
	char d;

	//check for recursion
	len=strlen(source);
	while(1)
		{
			s=source[i];
			d=dest[j];

			if(((s=='/' || s=='\\') && (d=='/' || d=='\\')) || s==d)
				{
					i++;
					j++;
				}
			else
				{
					if(i==len)return 1;
					else return 0;
				}

			//if we have a weird path, like c://\ then increment i or j to skip the extra char
			if((s=='/' || s=='\\') && (source[i]=='/' || source[i]=='\\'))
			i++;

			//if we have a weird path, like c://\ then increment i or j to skip the extra char
			if((d=='/' || d=='\\') && (dest[j]=='/' || dest[j]=='\\'))
			j++;

		}

}

int copy_dir(char *dest, char *source)
{
	DIR *dp;
	struct dirent *ep;
	int file_attributes;
	struct stat buf;
	struct utimbuf ut;
	char is_dir=0;
	char is_link=0;
	char is_special=0;
	char full_source_path_string[MAX_PATH];
	char full_dest_path_string[MAX_PATH];
	int result;
	int no_errors=1;
	int dest_exists;

	if(is_dir_recursive(dest,source))return 0;

	stat(source, &buf);

	dp = opendir(source);
	if(dp != NULL)
	{
		dest_exists=does_dir_exist(dest);
		if(!dest_exists)
			{
#ifndef WINDOWS
				result=mkdir(dest,buf.st_mode);
#else
				result=mkdir(dest);
#endif
				if(result==-1 && error_decision!=ERROR_DECISSION_IGNORE)
					{
						char str[200];
						format_errno_error(str);
						set_error(str, dest);

						while(error_decision==ERROR_DECISSION_PENDING)
#ifndef WINDOWS
						usleep(5);
#else
						Sleep(5);
#endif
					}

				if(result==-1)return 0;
			}

	 	while(ep = readdir(dp))
	 		{
				if(overwrite_decision==OVERWRITE_FILE_CANCEL || cancel_copy || error_decision==ERROR_DECISSION_CANCEL)break;

				//remove the "." entry
				if(ep->d_name[0]=='.' && ep->d_name[1]==0)continue;
				if(ep->d_name[0]=='.' && ep->d_name[1]=='.' && ep->d_name[2]==0)continue;

				strcpy(full_source_path_string,source);
				strcat(full_source_path_string,"/");
				strcat(full_source_path_string,ep->d_name);

				strcpy(full_dest_path_string,dest);
				strcat(full_dest_path_string,"/");
				strcat(full_dest_path_string,ep->d_name);

//windows doesn't have the d_type field
#ifndef WINDOWS
				if(ep->d_type==DT_DIR)is_dir=1;
				else is_dir=0;
				if(ep->d_type==DT_LNK)is_link=1;
				else is_link=0;

				if(ep->d_type==DT_BLK)is_special=SPECIAL_TYPE_BLOCK_DEV;
				else
				if(ep->d_type==DT_CHR)is_special=SPECIAL_TYPE_CHAR_DEV;
				else
				if(ep->d_type==DT_FIFO)is_special=SPECIAL_TYPE_PIPE;
				else
				if(ep->d_type==DT_SOCK)is_special=SPECIAL_TYPE_SOCK;


#else

				file_attributes=GetFileAttributes(full_source_path_string);
				if(file_attributes & FILE_ATTRIBUTE_DIRECTORY)is_dir=1;
				else is_dir=0;
#endif

#ifndef WINDOWS
				if(is_link)
					{
						no_errors=copy_link(full_dest_path_string, full_source_path_string);
					}
				else
#endif
					{
						if(is_dir)
							{
								no_errors=copy_dir(full_dest_path_string, full_source_path_string);
							}
						else
							{
								struct stat buf2;
								stat(full_source_path_string, &buf2);
								no_errors=copy_single_file(full_dest_path_string, full_source_path_string, buf2.st_size,is_special);
							}
					}
			}

	 	(void)closedir(dp);

#ifndef WINDOWS
		//set the time
		ut.actime=buf.st_atime;
		ut.modtime=buf.st_mtime;
		result=utime(dest, &ut);

		if(result==-1 && error_decision!=ERROR_DECISSION_IGNORE)
			{
				char str[200];
				format_errno_error(str);
				set_error(str, dest);

				while(error_decision==ERROR_DECISSION_PENDING)
				usleep(5);
			}
#else
if(!dest_exists)//do not change the date/time of existing dirs to match the old dir
		{
			FILETIME ft;
			HANDLE src_dir;
			HANDLE dst_dir;

			src_dir=CreateFile(source,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_ALWAYS,FILE_FLAG_BACKUP_SEMANTICS,NULL);
			result=GetLastError();
			dst_dir=CreateFile(dest,GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_ALWAYS,FILE_FLAG_BACKUP_SEMANTICS,NULL);

			result=GetFileTime(src_dir,NULL,NULL, &ft);
			result=SetFileTime(dst_dir,NULL,NULL, &ft);
			CloseHandle(src_dir);
			CloseHandle(dst_dir);
		}
#endif
	}

	return no_errors;
}

int copy_files(void *unused)
{
	int selected_dirs=0;
	int selected_files=0;
	int i;
	char full_path_string[MAX_PATH];
	char processed_path[MAX_PATH];
	int dst_len=strlen(dest_copy_text);
	struct stat st;
	int dest_exists;
	int result;

	cancel_copy=0;

	strcpy(processed_path,dest_copy_text);

#ifdef WINDOWS
	if(dst_len>3)
#endif
	if((processed_path[dst_len-1]=='/' || processed_path[dst_len-1]=='\\') && dst_len>1)
	processed_path[dst_len-1]=0;

	if(stat(processed_path,&st)==0)dest_exists=1;
	else dest_exists=0;

	files_copied=0;
	files_copied_until_now_size=0;
	files_to_be_copied_size=0;
	this_file_copying_size=0;
	this_file_copied_size=0;

	update_screen=1;

	overwrite_decision=OVERWRITE_FILE_PENDING;
	error_decision=ERROR_DECISSION_PENDING;

	//check if paths are valid and stuff

	//calculate total size
	files_size=0;
	for(i=0;i<panels[active_panel].number_of_files;i++)
	if(panels[active_panel].panel_files[i].selected)
		{
#ifndef WINDOWS
			if(panels[active_panel].panel_files[i].is_link)
				{
					selected_files++;
				}
			else
#endif
			if(panels[active_panel].panel_files[i].is_dir)
				{
					strcpy(full_path_string,panels[active_panel].dir_path);
					strcat(full_path_string,"/");
					strcat(full_path_string,panels[active_panel].panel_files[i].name);

					pre_get_dir_size(full_path_string);
	 				selected_dirs++;
				}
	 		else
	 			{
					files_size+=panels[active_panel].panel_files[i].st_size;
	 				selected_files++;
				}
		}
	files_to_be_copied_size=files_size;

	if(cancel_copy)return 0;


	//single file only
	if(!selected_files && !selected_dirs)
		{
			int this_is_dir=panels[active_panel].panel_files[panels[active_panel].panel_files_order[panels[active_panel].cursor_file]].is_dir;

			if(this_is_dir)
				{
					strcpy(full_path_string,panels[active_panel].dir_path);
					strcat(full_path_string,"/");
					strcat(full_path_string,panels[active_panel].panel_files[panels[active_panel].panel_files_order[panels[active_panel].cursor_file]].name);
					pre_get_dir_size(full_path_string);
					if(cancel_copy)return 0;
					files_to_be_copied_size=files_size;
				}
			else
			files_to_be_copied_size=panels[active_panel].panel_files[panels[active_panel].panel_files_order[panels[active_panel].cursor_file]].st_size;


			if(dest_exists)
				{
					//destination path exists, no problems
					prepare_to_copy_single_file(panels[active_panel].panel_files_order[panels[active_panel].cursor_file],0);
				}
			else
				{
					//copy a file or directory into something that doesn't exist, so preserve the path
					prepare_to_copy_single_file(panels[active_panel].panel_files_order[panels[active_panel].cursor_file],1);
				}


		}
	else//selected files
		{
			if(!dest_exists)
				{
					if(dest_copy_text[dst_len-1]!='/' && dest_copy_text[dst_len-1]!='\\')
#ifndef WINDOWS
					strcat(dest_copy_text,"/");
					result=mkdir(dest_copy_text,(S_IRWXU|S_IRWXG|S_IRWXO));
#else
					strcat(dest_copy_text,"\\");
					result=mkdir(dest_copy_text);
#endif

					if(result==-1 && error_decision!=ERROR_DECISSION_IGNORE)
						{
							char str[200];
							format_errno_error(str);
							set_error(str, dest_copy_text);

							while(error_decision==ERROR_DECISSION_PENDING)
#ifndef WINDOWS
							usleep(5);
#else
							Sleep(5);
#endif
						}
					if(result==-1)return 0;
				}

			for(i=0;i<panels[active_panel].number_of_files;i++)
			if(panels[active_panel].panel_files[i].selected)
				{
					if(overwrite_decision==OVERWRITE_FILE_CANCEL || cancel_copy || error_decision==ERROR_DECISSION_CANCEL)break;
					panels[active_panel].panel_files[i].selected=0;
			 		prepare_to_copy_single_file(i,0);
				}
		}

	menus[copying_menu_id].opened=0;
	panels[!active_panel].needs_reread=1;
	panels[!active_panel].cursor_file=0;
	panels[active_panel].needs_reread=1;
	panels[active_panel].cursor_file=0;
	update_screen=1;

	return 1;

}

void delete_dir(char *cur_dir)
{
	DIR *dp;
	struct dirent *ep;
	int file_attributes;
	struct stat buf;
	int is_dir=0;
	int is_link=0;
	char full_path_string[MAX_PATH];

	if(cancel_delete)return;

	dp = opendir (cur_dir);
	if(dp != NULL)
	{
	 	while(ep = readdir(dp))
	 		{
				//remove the "." entry
				if(ep->d_name[0]=='.' && ep->d_name[1]==0)continue;
				if(ep->d_name[0]=='.' && ep->d_name[1]=='.' && ep->d_name[2]==0)continue;

				strcpy(full_path_string,cur_dir);
				strcat(full_path_string,"/");
				strcat(full_path_string,ep->d_name);

//windows doesn't have the d_type field
#ifndef WINDOWS
				if(ep->d_type==DT_DIR)is_dir=1;
				else is_dir=0;
				if(ep->d_type==DT_LNK)is_link=1;
				else is_link=0;
#else
				file_attributes=GetFileAttributes(full_path_string);
				if(file_attributes & FILE_ATTRIBUTE_DIRECTORY)is_dir=1;
				else is_dir=0;
#endif


				if(is_dir && !is_link)
					{
						delete_dir(full_path_string);
					}
				else
					{
						delete_single_file(full_path_string,is_link);
					}
			}

	 	(void)closedir(dp);

	 	rmdir(cur_dir);
	}
}

int delete_single_file(char *source, int is_link)
{
	int result;

	strcpy(current_deleting_file,source);

#ifdef WINDOWS
			SetFileAttributes(source,FILE_ATTRIBUTE_NORMAL);
			DeleteFile(source);
#else

			if(!is_link)chmod(source, S_IWRITE);
			result=unlink(source);
			if(result==-1 && error_decision!=ERROR_DECISSION_IGNORE)
				{
					char str[200];
					format_errno_error(str);
					set_error(str, source);

					while(error_decision==ERROR_DECISSION_PENDING)
					usleep(5);
				}
#endif

	update_screen=1;
}

int delete_files(void *unused)
{
	int selected_dirs=0;
	int selected_files=0;
	int i;
	char full_path_string[MAX_PATH];
	char processed_path[MAX_PATH];
	struct stat st;
	int result;

	cancel_delete=0;

	error_decision=ERROR_DECISSION_PENDING;

	for(i=0;i<panels[active_panel].number_of_files;i++)
	if(panels[active_panel].panel_files[i].selected)
		{
			if(panels[active_panel].panel_files[i].is_dir)
				{
	 				selected_dirs++;
				}
	 		else
	 			{
	 				selected_files++;
				}
		}

	//single file only
	if(!selected_files && !selected_dirs)
		{
			int this_is_dir=panels[active_panel].panel_files[panels[active_panel].panel_files_order[panels[active_panel].cursor_file]].is_dir;
			int this_is_link=panels[active_panel].panel_files[panels[active_panel].panel_files_order[panels[active_panel].cursor_file]].is_link;

			strcpy(full_path_string,panels[active_panel].dir_path);
			strcat(full_path_string,"/");
			strcat(full_path_string,panels[active_panel].panel_files[panels[active_panel].panel_files_order[panels[active_panel].cursor_file]].name);

			if(this_is_dir && !this_is_link)
			delete_dir(full_path_string);
			else
			delete_single_file(full_path_string,this_is_link);

		}
	else//selected files
		{
			for(i=0;i<panels[active_panel].number_of_files;i++)
			if(panels[active_panel].panel_files[i].selected)
				{
					if(cancel_delete)break;
					panels[active_panel].panel_files[i].selected=0;

					strcpy(full_path_string,panels[active_panel].dir_path);
					strcat(full_path_string,"/");
					strcat(full_path_string,panels[active_panel].panel_files[i].name);

					if(panels[active_panel].panel_files[i].is_dir && !panels[active_panel].panel_files[i].is_link)
					delete_dir(full_path_string);
					else
			 		delete_single_file(full_path_string,panels[active_panel].panel_files[i].is_link);
				}
		}


	menus[deleting_menu_id].opened=0;
	panels[active_panel].needs_reread=1;
	update_screen=1;
}

void move_single_file(int file_pos,int preserve_path)
{
	char source_fn[MAX_PATH];
	char dest_fn[MAX_PATH];
	char *file_name;
	//set up stuff
	//cancel_copy=0;
	int result;
	char str[256];
	struct stat st;

	file_name=panels[active_panel].panel_files[file_pos].name;
	strcpy(source_fn,panels[active_panel].dir_path);
	strcat(source_fn,"/");
	strcat(source_fn,file_name);

	strcpy(dest_fn,dest_copy_text);
	if(!preserve_path)
		{
			strcat(dest_fn,file_name);
		}

	//if destination exists and is a dir, we just merge them vs copy/delete
	if(does_dir_exist(dest_fn) && !panels[active_panel].panel_files[file_pos].is_link && panels[active_panel].panel_files[file_pos].is_dir)
		{
			menus[copying_menu_id].opened=1;
			files_copied=0;
			files_copied_until_now_size=0;
			update_screen=1;

			pre_get_dir_size(source_fn);
			if(cancel_copy)return;

			files_to_be_copied_size=files_size;

			if(copy_dir(dest_fn, source_fn))
				{
					if(overwrite_decision!=OVERWRITE_FILE_CANCEL && !cancel_copy && error_decision!=ERROR_DECISSION_CANCEL)
					delete_dir(source_fn);
				}

			menus[copying_menu_id].opened=0;
			panels[!active_panel].needs_reread=1;
			panels[!active_panel].cursor_file=0;
			panels[active_panel].needs_reread=1;
			panels[active_panel].cursor_file=0;
			update_screen=1;
			return;
		}
	else
		{
			if(stat(dest_fn,&st)==0)
			if(!file_exists_ask_overwrite(source_fn,dest_fn,1))return;
		}

	result=rename(source_fn,dest_fn);

#ifdef WINDOWS
	if(result==-1 && errno==EACCES)//must use copy and delete
		{
#else
	if(result==-1 && errno==EXDEV)//must use copy and delete
		{

			if(panels[active_panel].panel_files[file_pos].is_link)
				{
					if(copy_link(dest_fn, source_fn))
					if(overwrite_decision!=OVERWRITE_FILE_CANCEL && !cancel_copy && error_decision!=ERROR_DECISSION_CANCEL)
					unlink(source_fn);

					return;
				}
#endif
			menus[copying_menu_id].opened=1;
			files_copied=0;
			files_copied_until_now_size=0;

			if(panels[active_panel].panel_files[file_pos].is_dir)
				{
					pre_get_dir_size(source_fn);
					if(cancel_copy)return;

					files_to_be_copied_size=files_size;

					if(copy_dir(dest_fn, source_fn))
						{
							if(overwrite_decision!=OVERWRITE_FILE_CANCEL && !cancel_copy && error_decision!=ERROR_DECISSION_CANCEL)
							delete_dir(source_fn);
						}

				}
			else
				{
					files_to_be_copied_size=panels[active_panel].panel_files[file_pos].st_size;
					if(copy_single_file(dest_fn, source_fn,panels[active_panel].panel_files[file_pos].st_size,panels[active_panel].panel_files[file_pos].is_special))
					if(overwrite_decision!=OVERWRITE_FILE_CANCEL && !cancel_copy && error_decision!=ERROR_DECISSION_CANCEL)
						{
#ifdef WINDOWS
							SetFileAttributes(source_fn,FILE_ATTRIBUTE_NORMAL);
#else

							chmod(source_fn, S_IWRITE);
#endif
							unlink(source_fn);
						}
				}
			menus[copying_menu_id].opened=0;
			panels[!active_panel].needs_reread=1;
			panels[!active_panel].cursor_file=0;
			panels[active_panel].needs_reread=1;
			panels[active_panel].cursor_file=0;
			update_screen=1;
			return;
		}

	if(result==-1)
		{
			format_errno_error(str);
			set_error(str, dest_fn);
		}


}

int move_files(void *unused)
{
	int selected_files=0;
	int i;
	char full_path_string[MAX_PATH];
	char processed_path[MAX_PATH];
	int dst_len=strlen(dest_copy_text);
	struct stat st;
	int dest_exists;
	int result;

	cancel_copy=0;


	strcpy(processed_path,dest_copy_text);

#ifdef WINDOWS
	if(dst_len>3)
#endif
	if((processed_path[dst_len-1]=='/' || processed_path[dst_len-1]=='\\') && dst_len>1)
	processed_path[dst_len-1]=0;

	if(stat(processed_path,&st)==0)dest_exists=1;
	else dest_exists=0;

	overwrite_decision=OVERWRITE_FILE_PENDING;
	error_decision=ERROR_DECISSION_PENDING;

	//check if paths are valid and stuff

	for(i=0;i<panels[active_panel].number_of_files;i++)
	if(panels[active_panel].panel_files[i].selected)
	selected_files++;


	//single file only
	if(!selected_files)
		{
			if(dest_exists)
				{
					//destination path exists, no problems
					move_single_file(panels[active_panel].panel_files_order[panels[active_panel].cursor_file],0);
				}
			else
				{
					//copy a file or directory into something that doesn't exist, so preserve the path
					move_single_file(panels[active_panel].panel_files_order[panels[active_panel].cursor_file],1);
				}


		}
	else//selected files
		{
			if(!dest_exists)
				{
					if(dest_copy_text[dst_len-1]!='/' && dest_copy_text[dst_len-1]!='\\')
#ifndef WINDOWS
					strcat(dest_copy_text,"/");
					result=mkdir(dest_copy_text,(S_IRWXU|S_IRWXG|S_IRWXO));
#else
					strcat(dest_copy_text,"\\");
					result=mkdir(dest_copy_text);
#endif
				}

			for(i=0;i<panels[active_panel].number_of_files;i++)
			if(panels[active_panel].panel_files[i].selected)
				{
					if(overwrite_decision==OVERWRITE_FILE_CANCEL || cancel_copy || error_decision==ERROR_DECISSION_CANCEL)break;
					panels[active_panel].panel_files[i].selected=0;
			 		move_single_file(i,0);
				}
		}

	update_screen=1;
	menus[copying_menu_id].opened=0;
	panels[!active_panel].needs_reread=1;
	panels[!active_panel].cursor_file=0;
	panels[active_panel].needs_reread=1;
	panels[active_panel].cursor_file=0;

}















