#ifndef __FILE_OPERATIONS_H__
#define __FILE_OPERATIONS_H__

#define ACTION_TYPE_COUNT_SIZE 0

//ovewrite decisions
#define OVERWRITE_FILE_PENDING 0
#define OVERWRITE_FILE_SKIP_THIS 1
#define OVERWRITE_FILE_SKIP_ALL 2
#define OVERWRITE_FILE_OVERWRITE_THIS 3
#define OVERWRITE_FILE_OVERWRITE_ALL 4
#define OVERWRITE_FILE_CANCEL 5

#define ERROR_DECISSION_PENDING 0
#define ERROR_DECISSION_OK 1
#define ERROR_DECISSION_CANCEL 2
#define ERROR_DECISSION_IGNORE 3

extern int move_instead_of_copy;

extern char source_copy_text[MAX_PATH];
extern char dest_copy_text[MAX_PATH];

extern unsigned long long int files_size;

extern char current_copying_file[MAX_PATH];
extern char current_copying_file_dest[MAX_PATH];

extern char current_deleting_file[MAX_PATH];

extern int files_to_be_copied;
extern int files_copied;
extern int abort_copy;
extern int time_copy_started;
extern int time_copy_paused;
extern int cancel_copy;
extern int cancel_delete;
extern unsigned long long int files_to_be_copied_size;
extern unsigned long long int files_copied_size;
extern unsigned long long int this_file_copying_size;
extern unsigned long long int this_file_copied_size;

extern char overwrite_source_date[128];
extern char overwrite_dest_date[128];
extern char overwrite_source_size[64];
extern char overwrite_dest_size[64];
extern int overwrite_decision;

extern char error_text[128];
extern char aux_error_text[128];
extern int error_decision;

int copy_files(void *unused);
int copy_dir(char *dest, char *source);

int delete_files(void *unused);

unsigned long long int get_disk_space(char *path);
void get_dir_size(char *cur_dir);

int delete_single_file(char *source, int is_link);
int move_files(void *unused);

#endif
