#include "global.h"

int read_cur_dir(char *cur_dir, my_file *files_list, int *files_order)
{
	DIR *dp;
	struct dirent *ep;
	int i=0;
	int files_no=0;
	int file_attributes;
	//struct stat buf;
#ifndef WINDOWS
	struct stat64 buf;
#else
	struct _stati64 buf;
#endif

	dp = opendir (cur_dir);
	if(dp != NULL)
	{
	 	while(ep = readdir(dp))
	 		{
				//remove the "." entry
				if(ep->d_name[0]=='.' && ep->d_name[1]==0)continue;

				//for linux, remove the  ".." crap from the root dir
				if(cur_dir[0]=='/' && !cur_dir[1])
				if(ep->d_name[0]=='.' && ep->d_name[1]=='.' && ep->d_name[2]==0)continue;

//windows doesn't have the d_type field
#ifndef WINDOWS
				if(ep->d_type==DT_DIR)files_list[i].is_dir=1;
				else files_list[i].is_dir=0;

				if(ep->d_type==DT_LNK)
					{
						DIR *dp_test;
						struct stat st;

						files_list[i].is_link=1;

						//check if broken
						if(stat(ep->d_name,&st) == 0)
						files_list[i].is_broken=0;
						else
						files_list[i].is_broken=1;

						//if link, see if it is a directory
						if(!files_list[i].is_broken)
							{
								dp_test = opendir(ep->d_name);
								if(dp_test)
									{
										files_list[i].is_dir=1;
										closedir(dp_test);
									}
								else files_list[i].is_dir=0;
							}

					}
				else files_list[i].is_link=0;

				if(ep->d_type==DT_BLK)files_list[i].is_special=SPECIAL_TYPE_BLOCK_DEV;
				else
				if(ep->d_type==DT_CHR)files_list[i].is_special=SPECIAL_TYPE_CHAR_DEV;
				else
				if(ep->d_type==DT_FIFO)files_list[i].is_special=SPECIAL_TYPE_PIPE;
				else
				if(ep->d_type==DT_SOCK)files_list[i].is_special=SPECIAL_TYPE_SOCK;
				else
				files_list[i].is_special=SPECIAL_TYPE_NONE;


				if(ep->d_name[0]=='.' && ep->d_name[1]!=0 && ep->d_name[1]!='.')
					{
						if(!show_hidden)continue;
						files_list[i].is_hidden=1;
					}
				else files_list[i].is_hidden=0;

#else

				file_attributes=GetFileAttributes(ep->d_name);
				if(file_attributes!=INVALID_FILE_ATTRIBUTES)
					{
						if(file_attributes & FILE_ATTRIBUTE_DIRECTORY)files_list[i].is_dir=1;
						else files_list[i].is_dir=0;
					}
				else
					{
						file_attributes=0;
						files_list[i].is_dir=0;
					}

				if(file_attributes & FILE_ATTRIBUTE_HIDDEN)
					{
						if(!show_hidden)continue;
						files_list[i].is_hidden=1;
					}
				else files_list[i].is_hidden=0;

				files_list[i].windows_attributes=file_attributes;

				files_list[i].is_link=0;
				files_list[i].is_special=SPECIAL_TYPE_NONE;

#endif

				//stat(ep->d_name, &buf);
				//_stat64(ep->d_name, &buf);

#ifndef WINDOWS
				stat64(ep->d_name, &buf);
#else
				_stati64(ep->d_name, &buf);
#endif
				files_list[i].st_size=buf.st_size;
				files_list[i].st_mode=buf.st_mode;
				files_list[i].mtime=buf.st_mtime;
#ifndef WINDOWS
				files_list[i].st_uid=buf.st_uid;
				files_list[i].st_gid=buf.st_gid;
#endif
				files_list[i].ext[0]=0;//clear the extension
				files_list[i].selected=0;

#ifndef WINDOWS
				if(!files_list[i].is_dir && (buf.st_mode & 0111))
				files_list[i].is_exe=1;
				else
				files_list[i].is_exe=0;
#endif

				strcpy(files_list[i].name,ep->d_name);
				files_order[i]=i;
				i++;
				files_no++;
			}
	 	(void)closedir(dp);
	}

	return files_no;

}

//1 found, 0 not found
int find_extension_in_string(char *ext, char *ext_string)
{
	int i,k,match_counter;
	int ext_len=strlen(ext);
	int ext_str_len=strlen(ext_string);
	char cur_ext_str_char;
	char cur_ext_string_str_char;

	if(!ext_len || !ext_str_len)return 0;//does not belong

	k=0;
	i=0;
	match_counter=0;

	//debug stuff
	if(!strcmp(ext,"gz"))
	i=0;

	while(1)
		{
			cur_ext_str_char=ext[i];
			cur_ext_string_str_char=ext_string[k];

			//make it case insensitive
			if(cur_ext_str_char>=65 && cur_ext_str_char<=90)cur_ext_str_char+=32;
			if(cur_ext_string_str_char>=65 && cur_ext_string_str_char<=90)cur_ext_string_str_char+=32;

			if(cur_ext_str_char!=cur_ext_string_str_char)
				{
					i=0;
					match_counter=0;
				}
			else
				{
					match_counter++;
					i++;
				}

			if(match_counter==ext_len)
				{
					if((ext_string[k+1]==';' || k==ext_str_len) && (k+1-ext_len==0 || ext_string[k-ext_len]==';'))
					return 1;
					else
						{
							i=0;
							match_counter=0;
						}

				}


			k++;
			if(k>=ext_str_len)return 0;

		}

	return 0;

}

void do_files_grouping(my_file *files_list, int *files_order, int files_no)
{
	int i,j,len;
	int k;

	//get the file extension
	for(i=0;i<files_no;i++)
		{
			//no extension for directories
			if(files_list[i].is_dir)
				{
					files_list[i].ext[0]=0;//clear the extension
					continue;
				}

			len=strlen(files_list[i].name);

			if(len)
				{
					for(j=len-1;j--;j)
						{
							if(files_list[i].name[j]=='.')break;
						}
					if(!j)continue;//no extension, move to the next file
					if(j==len-1)continue;//no extension, move to the next file

					if(len-j>=EXTENSION_MAX)continue;//extension too big

					j++;//get after the dot
					k=0;
					for(j;j<len;j++)
						{
							files_list[i].ext[k]=files_list[i].name[j];
							k++;
						}

					files_list[i].ext[k]=0;//null terminate it


				}
		}

	//now do the grouping
	//get the file extension
	for(i=0;i<files_no;i++)
		{
			files_list[i].group=-1;
			files_list[i].priority=127;

			//no groups for directories
			if(files_list[i].is_dir)
				{
					continue;
				}

			//go through all the groups
			for(j=0;j<MAX_GROUPS;j++)
				{
#ifndef WINDOWS
					if(files_list[i].is_exe)
						{
							files_list[i].group=0;
							files_list[i].priority=groups[0].priority;
							break;
						}
#endif
					if(files_list[i].group==-1)//only go through files not assigned to groups yet
					if(find_extension_in_string(files_list[i].ext, groups[j].extensions))
						{
							files_list[i].group=j;
							files_list[i].priority=groups[j].priority;
							break;
						}
				}
		}

}

my_file *files_list_for_sort;

int file_name_sort(const void *a, const void *b)
{
	int file_1=*(int*)a;
	int file_2=*(int*)b;

	if(files_list_for_sort[file_2].name[0]=='.' && files_list_for_sort[file_2].name[1]=='.' && !files_list_for_sort[file_2].name[2])return 1;
	if(files_list_for_sort[file_1].name[0]=='.' && files_list_for_sort[file_1].name[1]=='.' && !files_list_for_sort[file_1].name[2])return -1;

	if(!files_list_for_sort[file_1].is_dir && files_list_for_sort[file_2].is_dir)return 1;
	if(files_list_for_sort[file_1].is_dir && !files_list_for_sort[file_2].is_dir)return -1;


	return strncasecmp(files_list_for_sort[file_1].name, files_list_for_sort[file_2].name, FILENAME_MAX);
}

int file_ext_sort(const void *a, const void *b)
{
	int file_1=*(int*)a;
	int file_2=*(int*)b;
	int ret_value;

	if(files_list_for_sort[file_2].name[0]=='.' && files_list_for_sort[file_2].name[1]=='.' && !files_list_for_sort[file_2].name[2])return 1;
	if(files_list_for_sort[file_1].name[0]=='.' && files_list_for_sort[file_1].name[1]=='.' && !files_list_for_sort[file_1].name[2])return -1;

	if(!files_list_for_sort[file_1].is_dir && files_list_for_sort[file_2].is_dir)return 1;
	if(files_list_for_sort[file_1].is_dir && !files_list_for_sort[file_2].is_dir)return -1;

	ret_value=strncasecmp(files_list_for_sort[file_1].ext, files_list_for_sort[file_2].ext, FILENAME_MAX);
	if(ret_value)return ret_value;//different extension, return

	//sort by name
	return strncasecmp(files_list_for_sort[file_1].name, files_list_for_sort[file_2].name, FILENAME_MAX);

}

int file_group_sort(const void *a, const void *b)
{
	int file_1=*(int*)a;
	int file_2=*(int*)b;
	int ret_value;
	int priority_1;
	int priority_2;

	if(files_list_for_sort[file_2].name[0]=='.' && files_list_for_sort[file_2].name[1]=='.' && !files_list_for_sort[file_2].name[2])return 1;
	if(files_list_for_sort[file_1].name[0]=='.' && files_list_for_sort[file_1].name[1]=='.' && !files_list_for_sort[file_1].name[2])return -1;

	if(!files_list_for_sort[file_1].is_dir && files_list_for_sort[file_2].is_dir)return 1;
	if(files_list_for_sort[file_1].is_dir && !files_list_for_sort[file_2].is_dir)return -1;

	priority_1=files_list_for_sort[file_1].priority;
	priority_2=files_list_for_sort[file_2].priority;

	if(priority_1>priority_2)return 1;
	else
	if(priority_1<priority_2)return -1;

	//priorities equal, sort by extension

	ret_value=strncasecmp(files_list_for_sort[file_1].ext, files_list_for_sort[file_2].ext, FILENAME_MAX);
	if(ret_value)return ret_value;//different extension, return

	//sort by name
	return strncasecmp(files_list_for_sort[file_1].name, files_list_for_sort[file_2].name, FILENAME_MAX);
}

int file_size_asc_sort(const void *a, const void *b)
{
	int file_1=*(int*)a;
	int file_2=*(int*)b;
	int ret_value;
	int st_size_1;
	int st_size_2;

	if(files_list_for_sort[file_2].name[0]=='.' && files_list_for_sort[file_2].name[1]=='.' && !files_list_for_sort[file_2].name[2])return 1;
	if(files_list_for_sort[file_1].name[0]=='.' && files_list_for_sort[file_1].name[1]=='.' && !files_list_for_sort[file_1].name[2])return -1;

	if(!files_list_for_sort[file_1].is_dir && files_list_for_sort[file_2].is_dir)return 1;
	if(files_list_for_sort[file_1].is_dir && !files_list_for_sort[file_2].is_dir)return -1;

	st_size_1=files_list_for_sort[file_1].st_size;
	st_size_2=files_list_for_sort[file_2].st_size;

	if(st_size_1>st_size_2)return 1;
	else
	if(st_size_1<st_size_2)return -1;

	//sizes equal, sort by name

	//sort by name
	return strncasecmp(files_list_for_sort[file_1].name, files_list_for_sort[file_2].name, FILENAME_MAX);
}

int file_size_desc_sort(const void *a, const void *b)
{
	int file_1=*(int*)a;
	int file_2=*(int*)b;
	int ret_value;
	int st_size_1;
	int st_size_2;

	if(files_list_for_sort[file_2].name[0]=='.' && files_list_for_sort[file_2].name[1]=='.' && !files_list_for_sort[file_2].name[2])return 1;
	if(files_list_for_sort[file_1].name[0]=='.' && files_list_for_sort[file_1].name[1]=='.' && !files_list_for_sort[file_1].name[2])return -1;

	if(!files_list_for_sort[file_1].is_dir && files_list_for_sort[file_2].is_dir)return 1;
	if(files_list_for_sort[file_1].is_dir && !files_list_for_sort[file_2].is_dir)return -1;

	st_size_1=files_list_for_sort[file_1].st_size;
	st_size_2=files_list_for_sort[file_2].st_size;

	if(st_size_1>st_size_2)return -1;
	else
	if(st_size_1<st_size_2)return 1;

	//sizes equal, sort by name

	//sort by name
	return strncasecmp(files_list_for_sort[file_1].name, files_list_for_sort[file_2].name, FILENAME_MAX);
}

int file_time_asc_sort(const void *a, const void *b)
{
	int file_1=*(int*)a;
	int file_2=*(int*)b;
	int ret_value;
	int st_mtime_1;
	int st_mtime_2;

	if(files_list_for_sort[file_2].name[0]=='.' && files_list_for_sort[file_2].name[1]=='.' && !files_list_for_sort[file_2].name[2])return 1;
	if(files_list_for_sort[file_1].name[0]=='.' && files_list_for_sort[file_1].name[1]=='.' && !files_list_for_sort[file_1].name[2])return -1;

	if(!files_list_for_sort[file_1].is_dir && files_list_for_sort[file_2].is_dir)return 1;
	if(files_list_for_sort[file_1].is_dir && !files_list_for_sort[file_2].is_dir)return -1;

	st_mtime_1=files_list_for_sort[file_1].mtime;
	st_mtime_2=files_list_for_sort[file_2].mtime;

	if(st_mtime_1>st_mtime_2)return 1;
	else
	if(st_mtime_1<st_mtime_2)return -1;

	//times equal, sort by name

	//sort by name
	return strncasecmp(files_list_for_sort[file_1].name, files_list_for_sort[file_2].name, FILENAME_MAX);
}

int file_time_desc_sort(const void *a, const void *b)
{
	int file_1=*(int*)a;
	int file_2=*(int*)b;
	int ret_value;
	int st_mtime_1;
	int st_mtime_2;

	if(files_list_for_sort[file_2].name[0]=='.' && files_list_for_sort[file_2].name[1]=='.' && !files_list_for_sort[file_2].name[2])return 1;
	if(files_list_for_sort[file_1].name[0]=='.' && files_list_for_sort[file_1].name[1]=='.' && !files_list_for_sort[file_1].name[2])return -1;

	if(!files_list_for_sort[file_1].is_dir && files_list_for_sort[file_2].is_dir)return 1;
	if(files_list_for_sort[file_1].is_dir && !files_list_for_sort[file_2].is_dir)return -1;

	st_mtime_1=files_list_for_sort[file_1].mtime;
	st_mtime_2=files_list_for_sort[file_2].mtime;

	if(st_mtime_1>st_mtime_2)return -1;
	else
	if(st_mtime_1<st_mtime_2)return 1;

	//times equal, sort by name

	//sort by name
	return strncasecmp(files_list_for_sort[file_1].name, files_list_for_sort[file_2].name, FILENAME_MAX);
}

void sort_cur_dir(my_file *files_list, int *files_order, int files_no, char sort_type)
{
	int i;
	int any_changes;
	int temp;

	if(files_no<1)return;//nothing to sort

	files_list_for_sort=files_list;

	//sort by name
	if(sort_type==SORT_TYPE_NAME)
		{
			qsort(files_order,files_no,4,file_name_sort);
			return;
		}

	if(sort_type==SORT_TYPE_EXTENSION)
		{
			qsort(files_order,files_no,4,file_ext_sort);
			return;
		}

	if(sort_type==SORT_TYPE_GROUPS)
		{
			qsort(files_order,files_no,4,file_group_sort);
			return;
		}

	//sort by size
	if(sort_type==SORT_TYPE_SIZE_ASC)
		{
			qsort(files_order,files_no,4,file_size_asc_sort);
			return;
		}

	if(sort_type==SORT_TYPE_SIZE_DESC)
		{
			qsort(files_order,files_no,4,file_size_desc_sort);
			return;
		}

	//sort by date
	if(sort_type==SORT_TYPE_TIME_ASC)
		{
			qsort(files_order,files_no,4,file_time_asc_sort);
			return;
		}

	//sort by date
	if(sort_type==SORT_TYPE_TIME_DESC)
		{
			qsort(files_order,files_no,4,file_time_desc_sort);
			return;
		}
}





