#include "global.h"

void cls(SDL_Surface * this_screen)
{
  int some_module, my_pitch;
  int map_size;
  int i,j;

  my_pitch = this_screen->pitch;

  map_size = window_height * my_pitch;
  my_pitch = this_screen->pitch;
  //test to see if the map size is divisible by 4. If so, we clear the screen using a Dword
  some_module = map_size % 4;
  if(!some_module)		//yes, it is divisible by 4!
  {
    int *screen_buffer;
    screen_buffer = (int *) this_screen->pixels;
    for(i = 0; i < map_size / 4; i++)
	*(screen_buffer + i) = 0xfefefefe;
  }
  else if(some_module = 2)	//yes, it is divisible by 2!
  {
    short *screen_buffer;
    screen_buffer = (short *) this_screen->pixels;
    for(i = 0; i < map_size / 2; i++)
	*(screen_buffer + i) = 0xfefe;
  }
  else if(some_module = 1)
  {
    char *screen_buffer;
    screen_buffer = (char *) this_screen->pixels;
    for (i = 0; i < map_size; i++)
	*(screen_buffer + i) = 0xfe;
  }

}

void draw_line(SDL_Surface * this_screen, int xline, int yline, int width, int length, Uint8 line_color)
{
	int x, y, my_pitch;
	int start_pointer;
	Uint8 *screen_buffer;

	my_pitch = this_screen->pitch;
	screen_buffer = (Uint8 *)this_screen->pixels;

	for(y=0;y<width;y++)
		{
			start_pointer=my_pitch*(yline+y)+xline;
			for(x=0;x<length;x++)*(screen_buffer+start_pointer+x)=line_color;
		}

}

void draw_frame(SDL_Surface * this_screen, int xmenu, int ymenu, int xlen, int ylen, Uint8 border_color_1, Uint8 border_color_2)
{
	int x, y, my_pitch;
	Uint8 *screen_buffer;
	screen_buffer = (Uint8 *)this_screen->pixels;
	my_pitch = this_screen->pitch;

	if(xmenu + xlen>=my_pitch)xlen=my_pitch-xmenu-1;
	if(ymenu + ylen>=window_height)ylen=window_height-ymenu-1;

	if(xlen>0 && ylen>0)
		{
			for(x = xmenu; x < xmenu + xlen; x++)
			*(screen_buffer+my_pitch*ymenu+x) = border_color_1;

			for(y = ymenu; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu) = border_color_1;

			for(x = xmenu; x < xmenu + xlen + 1; x++)
			*(screen_buffer + my_pitch * (ymenu + ylen) + x) = border_color_2;

			for(y = ymenu; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu + xlen) = border_color_2;
		}
}


void draw_dotted_frame(SDL_Surface * this_screen, int xmenu, int ymenu, int xlen, int ylen, Uint8 color)
{
	int x, y, my_pitch;
	Uint8 *screen_buffer;
	screen_buffer = (Uint8 *)this_screen->pixels;
	my_pitch = this_screen->pitch;

	if(xmenu + xlen>=my_pitch)xlen=my_pitch-xmenu-1;
	if(ymenu + ylen>=window_height)ylen=window_height-ymenu-1;

	if(xlen>0 && ylen>0)
		{
			for(x = xmenu; x < xmenu + xlen; x+=2)
			*(screen_buffer+my_pitch*ymenu+x) = color;

			for(y = ymenu; y < ymenu + ylen; y+=2)
			*(screen_buffer + my_pitch * y + xmenu) = color;

			for(x = xmenu; x < xmenu + xlen + 1; x+=2)
			*(screen_buffer + my_pitch * (ymenu + ylen) + x) = color;

			for(y = ymenu; y < ymenu + ylen; y+=2)
			*(screen_buffer + my_pitch * y + xmenu + xlen) = color;
		}
}


void draw_frame_button(SDL_Surface * this_screen, int xmenu, int ymenu, int xlen, int ylen, Uint8 border_color_1, Uint8 border_color_2, Uint8 border_color_3)
{
	int x, y, my_pitch;
	Uint8 *screen_buffer;
	screen_buffer = (Uint8 *)this_screen->pixels;
	my_pitch = this_screen->pitch;

	if(xmenu + xlen>=my_pitch)xlen=my_pitch-xmenu-1;
	if(ymenu + ylen>=window_height)ylen=window_height-ymenu-1;

	if(xlen>0 && ylen>0)
		{
			for(x = xmenu; x < xmenu + xlen; x++)
			*(screen_buffer+my_pitch*ymenu+x) = border_color_1;

			for(y = ymenu; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu) = border_color_1;

			for(x = xmenu; x < xmenu + xlen + 1; x++)
			*(screen_buffer + my_pitch * (ymenu + ylen) + x) = border_color_2;

			for(y = ymenu; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu + xlen) = border_color_2;

			for(x = xmenu; x < xmenu + xlen; x++)
			*(screen_buffer + my_pitch * (ymenu-1 + ylen) + x) = border_color_3;

			for(y = ymenu; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu-1 + xlen) = border_color_3;
		}
}

void draw_description_frame(SDL_Surface * this_screen, char * text, int xmenu, int ymenu, int xlen, int ylen, Uint8 border_color_1, Uint8 border_color_2)
{
	int x, y, my_pitch;
	Uint8 *screen_buffer;
	screen_buffer = (Uint8 *)this_screen->pixels;
	my_pitch = this_screen->pitch;
	int text_w, text_h;

	my_TTF_SizeText(font_default, text, &text_w, &text_h);

	if(xmenu + xlen>=my_pitch)xlen=my_pitch-xmenu-1;
	if(ymenu + ylen>=window_height)ylen=window_height-ymenu-1;

	if(xlen>0 && ylen>0)
		{
			for(x = xmenu; x < xmenu + 15; x++)
			*(screen_buffer+my_pitch*ymenu+x) = border_color_1;

			for(x = xmenu+15+text_w; x < xmenu+xlen; x++)
			*(screen_buffer+my_pitch*ymenu+x) = border_color_1;

			for(x = xmenu; x < xmenu + 15; x++)
			*(screen_buffer+my_pitch*(ymenu+1)+x) = border_color_2;

			for(x = xmenu+15+text_w; x < xmenu+xlen; x++)
			*(screen_buffer+my_pitch*(ymenu+1)+x) = border_color_2;

			for(y = ymenu; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu) = border_color_1;

			for(y = ymenu+1; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu+1) = border_color_2;

			for(x = xmenu; x < xmenu + xlen + 1; x++)
			*(screen_buffer + my_pitch * (ymenu + ylen) + x) = border_color_2;

			for(y = ymenu; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu + xlen) = border_color_2;


			for(x = xmenu; x < xmenu + xlen; x++)
			*(screen_buffer + my_pitch * (ymenu-1 + ylen) + x) = border_color_1;

			for(y = ymenu; y < ymenu + ylen; y++)
			*(screen_buffer + my_pitch * y + xmenu-1 + xlen) = border_color_1;

	TTF_DrawText(screen, font_default,xmenu+15,ymenu-5,C_BLACK,text,315);
		}
}

void draw_empty_menu(SDL_Surface * this_screen, char color, int xmenu, int ymenu, int xlen, int ylen,  Uint8 border_color_1, Uint8 border_color_2)
{
	int x, y, my_pitch;
	char cur_pixel;
	Uint8 *screen_buffer;
	screen_buffer = (Uint8 *) this_screen->pixels;
	my_pitch = this_screen->pitch;
	screen_buffer += ymenu * my_pitch + xmenu;

	if(xmenu + xlen>=my_pitch)xlen=my_pitch-xmenu-1;
	if(ymenu + ylen>=window_height)ylen=window_height-ymenu-1;

	//draw the menu (without borders)
	for(y = ymenu; y < ymenu + ylen; y++)
	{
		for(x = xmenu; x < xmenu + xlen; x++)
		*(screen_buffer++)=color;

		screen_buffer+=(my_pitch - xlen);
	}

	draw_frame(screen, xmenu, ymenu, xlen, ylen, border_color_1,border_color_2);
}

void draw_empty_button(SDL_Surface * this_screen, char color, int xmenu, int ymenu, int xlen, int ylen,  Uint8 border_color_1, Uint8 border_color_2, Uint8 border_color_3)
{
	int x, y, my_pitch;
	char cur_pixel;
	Uint8 *screen_buffer;
	screen_buffer = (Uint8 *) this_screen->pixels;
	my_pitch = this_screen->pitch;
	screen_buffer += ymenu * my_pitch + xmenu;

	if(xmenu + xlen>=my_pitch)xlen=my_pitch-xmenu-1;
	if(ymenu + ylen>=window_height)ylen=window_height-ymenu-1;

	//draw the menu (without borders)
	for(y = ymenu; y < ymenu + ylen; y++)
	{
		for(x = xmenu; x < xmenu + xlen; x++)
		*(screen_buffer++)=color;

		screen_buffer+=(my_pitch - xlen);
	}

	draw_frame_button(screen, xmenu, ymenu, xlen, ylen, border_color_1,border_color_2,border_color_3);
}

void draw_menu_window(SDL_Surface * this_screen, char *title, char color, char title_bar_color, int xmenu, int ymenu, int xlen, int ylen,  Uint8 border_color_1, Uint8 border_color_2, Uint8 border_color_3)
{
	int x, y, my_pitch;
	char cur_pixel;
	Uint8 *screen_buffer;
	screen_buffer = (Uint8 *) this_screen->pixels;
	my_pitch = this_screen->pitch;
	screen_buffer += ymenu * my_pitch + xmenu;

	if(xmenu + xlen>=my_pitch)xlen=my_pitch-xmenu-1;
	if(ymenu + ylen>=window_height)ylen=window_height-ymenu-1;

	//draw the menu (without borders)
	for(y = ymenu; y < ymenu + ylen; y++)
	{
		for(x = xmenu; x < xmenu + xlen; x++)
		*(screen_buffer++)=color;

		screen_buffer+=(my_pitch - xlen);
	}

	draw_frame_button(screen, xmenu, ymenu, xlen, ylen, border_color_1,border_color_2,border_color_3);
	draw_line(screen, xmenu+2, ymenu+2, 20, xlen-4, title_bar_color);
	TTF_DrawText(screen, font_bold,xmenu+5,ymenu+4,C_WHITE,title,ylen-20);
}

void draw_tooltip(SDL_Surface * this_screen, char color, int xmenu, int ymenu,  Uint8 border_color, char * string)
{

	int x, y, my_pitch;
	int xlen, ylen;
	int x_menu,y_menu;
	char cur_pixel;
	Uint8 *screen_buffer;
	int text_w, text_h;


	x_menu=xmenu;
	y_menu=ymenu;

	my_TTF_SizeText(font_default, string, &text_w, &text_h);

	xlen=text_w+10;
	ylen=text_h+3;

	if(x_menu + xlen>=window_width)
	x_menu=window_width-xlen-1;
	if(y_menu + ylen>=window_height)
	y_menu=window_height-ylen-1;

	screen_buffer = (Uint8 *) this_screen->pixels;
	my_pitch = this_screen->pitch;
	screen_buffer += y_menu * my_pitch + x_menu;

	//draw the menu (without borders)
	//if(xlen>0 && ylen>0)
	for(y = y_menu; y < y_menu + ylen; y++)
	{
		for(x = x_menu; x < x_menu + xlen; x++)
		*(screen_buffer++)=color;

		screen_buffer+=(my_pitch - xlen);
	}

	draw_frame(screen, x_menu, y_menu, xlen, ylen, border_color,border_color);
	TTF_DrawText(screen, font_default,x_menu+2,y_menu+3,C_BLACK,string,xlen);
}

void draw_button(SDL_Surface * this_screen, char *text, int x, int y, int xlen, int ylen, int pressed, int active)
{
	int text_w,text_h;
	int x_text,y_text;

	my_TTF_SizeText(font_default, text, &text_w, &text_h);

	x_text=x+(xlen-text_w)/2;
	y_text=y+(ylen-text_h)/2;

	if(!pressed)draw_frame_button(screen, x, y, xlen, ylen, C_WHITE, C_DARK_GRAY, C_MEDIUM_GRAY);
	else draw_frame_button(screen, x, y, xlen, ylen, C_DARK_GRAY,C_WHITE,C_MEDIUM_GRAY);
	TTF_DrawText(screen, font_default,x_text,y_text+1,C_BLACK,text,300);
	if(active)draw_dotted_frame(screen, x+3, y+3, xlen-7, ylen-6, C_BLACK);

}




