#include "global.h"

int mkdir_menu_id=-1;
int sort_menu_id=-1;
int bookmarks_menu_id=-1;
int error_menu_id=-1;
int copy_menu_id=-1;
int copying_menu_id=-1;
int overwrite_menu_id=-1;
int delete_menu_id=-1;
int deleting_menu_id=-1;
int config_menu_id=-1;
int calculating_size_menu_id=-1;

void init_menus()
{
	int xpanel,ypanel;
	int y_len;
	int x_len;
	int bookmark_x_len=0;
	int bookmark_y_len=0;

	panels[0].x_pos_1=3;
	panels[0].y_pos_1=3;
	panels[0].x_pos_2=3+(window_width/2)-5;
	panels[0].y_pos_2=3+window_height-28;

	panels[1].x_pos_1=(window_width/2)+5;
	panels[1].y_pos_1=3;
	panels[1].x_pos_2=(window_width/2)+(window_width/2)-3;
	panels[1].y_pos_2=3+window_height-28;

	y_len=panels[active_panel].y_pos_2-panels[active_panel].y_pos_1;
	x_len=panels[active_panel].x_pos_2-panels[active_panel].x_pos_1;
	xpanel=panels[active_panel].x_pos_1;
	ypanel=panels[active_panel].y_pos_1;

	mkdir_menu_id=add_menu("Make Directory",(window_width-360)/2,(window_width-360)/2+360, (window_height-140)/2, (window_height-140)/2+140, draw_mkdir_menu, NULL, click_mkdir_menu, mkdir_menu_keypresses, 2);

	copy_menu_id=add_menu("Copy files",(window_width-400)/2,(window_width-400)/2+400, (window_height-170)/2, (window_height-170)/2+170, draw_copy_menu, NULL, click_copy_menu, copy_menu_keypresses, 2);
	copying_menu_id=add_menu("Copying files",(window_width-420)/2,(window_width-420)/2+420, (window_height-220)/2, (window_height-220)/2+220, draw_copying_menu, NULL, click_copying_menu, copying_menu_keypresses, 2);
	overwrite_menu_id=add_menu("Overwrite file?",(window_width-452)/2,(window_width-452)/2+452, (window_height-185)/2, (window_height-185)/2+185, draw_overwrite_menu, NULL, click_overwrite_menu, overwrite_menu_keypresses, 2);

	delete_menu_id=add_menu("Delete files",(window_width-360)/2,(window_width-360)/2+360, (window_height-150)/2, (window_height-150)/2+150, draw_delete_menu, NULL, click_delete_menu, delete_menu_keypresses, 2);
	deleting_menu_id=add_menu("Deleting files",(window_width-360)/2,(window_width-360)/2+360, (window_height-150)/2, (window_height-150)/2+150, draw_deleting_menu, NULL, click_deleting_menu, deleting_menu_keypresses, 2);

	config_menu_id=add_menu("Configuration",(window_width-500)/2,(window_width-500)/2+500, (window_height-300)/2, (window_height-300)/2+300, draw_config_menu, NULL, click_config_menu, config_keypresses, 2);

	calculating_size_menu_id=add_menu("Calculating size",(window_width-200)/2,(window_width-200)/2+200, (window_height-40)/2, (window_height-40)/2+40, draw_calculating_size_menu, NULL, NULL, NULL, 2);

	error_menu_id=add_menu("Error",(window_width-400)/2,(window_width-400)/2+400, (window_height-110)/2, (window_height-110)/2+110, draw_error_menu, NULL, click_error_menu, error_menu_keypresses, 2);


	sort_menu_id=add_menu("Sort by",xpanel+x_len-130,xpanel+x_len-10, ypanel+25, ypanel+25+145, draw_sort_menu, mouse_over_sort_menu, click_sort_menu, NULL, 2);

	//preserve the original length
	if(bookmarks_menu_id!=-1)
		{
			bookmark_x_len=menus[bookmarks_menu_id].x_2-menus[bookmarks_menu_id].x_1;
			bookmark_y_len=menus[bookmarks_menu_id].y_2-menus[bookmarks_menu_id].y_1;
		}

	bookmarks_menu_id=add_menu("Bookmarks",xpanel+20,xpanel+20+bookmark_x_len, ypanel+25, ypanel+25+bookmark_y_len, draw_bookmarks_menu, mouse_over_bookmarks_menu, click_bookmarks_menu, NULL, 2);

}

void init_editors_viewers()
{
	int i;

	strcpy(edit_with_list[0].edit_with,"c:\\program files\\gimp-2.0\\bin\\gimp-2.6.exe");
	strcpy(edit_with_list[0].extensions,"jpg;png;gif;tiff;tga");

	//strcpy(default_editor,"C:\\Program Files\\TextPad 4\\TextPad.exe");

}

void init_groups()
{
	int i;

	strcpy(groups[0].name,"Executable");
	strcpy(groups[0].extensions,"com;exe;bat;");
	groups[0].priority=1;
	groups[0].r=250;
	groups[0].g=30;
	groups[0].b=230;

	strcpy(groups[1].name,"Archives");
	strcpy(groups[1].extensions,"zip;rar;arj;gz;tar;tgz;bz2;lha;tg;7z;");
	groups[1].priority=2;
	groups[1].r=40;
	groups[1].g=250;
	groups[1].b=30;

	strcpy(groups[2].name,"Source files");
	strcpy(groups[2].extensions,"c;c++;cpp;h;bas;pas;asm;hpp;");
	groups[2].priority=3;
	groups[2].r=250;
	groups[2].g=20;
	groups[2].b=20;

	strcpy(groups[3].name,"Image files");
	strcpy(groups[3].extensions,"bmp;jpg;tiff;tga;pcx;dds;gif;png;");
	groups[3].priority=4;
	groups[3].r=200;
	groups[3].g=58;
	groups[3].b=17;

	strcpy(groups[4].name,"Text");
	strcpy(groups[4].extensions,"txt;ini;log;xml;");
	groups[4].priority=5;
	groups[4].r=160;
	groups[4].g=160;
	groups[4].b=160;

	strcpy(groups[5].name,"Videos");
	strcpy(groups[5].extensions,"avi;mp4;mov;");
	groups[5].priority=5;
	groups[5].r=34;
	groups[5].g=215;
	groups[5].b=255;

	//store the colors
	for(i=0;i<MAX_GROUPS;i++)
		{
			colors[i].r=groups[i].r;
			colors[i].g=groups[i].g;
			colors[i].b=groups[i].b;
		}

	SDL_SetPalette (screen, SDL_LOGPAL | SDL_PHYSPAL, colors, 0, MAX_GROUPS);
}

void init_sort_menu_entries()
{
	strcpy(sort_menu_entries[0].name,"Name");
	sort_menu_entries[0].sort_type=SORT_TYPE_NAME;

	strcpy(sort_menu_entries[1].name,"Extension");
	sort_menu_entries[1].sort_type=SORT_TYPE_EXTENSION;

	strcpy(sort_menu_entries[2].name,"Size Asc");
	sort_menu_entries[2].sort_type=SORT_TYPE_SIZE_ASC;

	strcpy(sort_menu_entries[3].name,"Size Desc");
	sort_menu_entries[3].sort_type=SORT_TYPE_SIZE_DESC;

	strcpy(sort_menu_entries[4].name,"Time Asc");
	sort_menu_entries[4].sort_type=SORT_TYPE_TIME_ASC;

	strcpy(sort_menu_entries[5].name,"Time Desc");
	sort_menu_entries[5].sort_type=SORT_TYPE_TIME_DESC;

	strcpy(sort_menu_entries[6].name,"Groups");
	sort_menu_entries[6].sort_type=SORT_TYPE_GROUPS;
}

void init_bottom_buttons()
{
	int i;

	for(i=0;i<10;i++)
		{
			bottom_buttons[i].pressed=0;
			bottom_buttons[i].press_func_normal=NULL;
			bottom_buttons[i].press_func_shift=NULL;
		}

	strcpy(bottom_buttons[0].name_normal,"F1-Help");

	strcpy(bottom_buttons[1].name_normal,"F2-User menu");

	strcpy(bottom_buttons[2].name_normal,"F3-View");
	strcpy(bottom_buttons[2].name_shift,"F3-Hex View");
	bottom_buttons[2].press_func_normal=view_file;
	bottom_buttons[2].press_func_shift=hex_view_file;

	strcpy(bottom_buttons[3].name_normal,"F4-Edit");
	strcpy(bottom_buttons[3].name_shift,"F4-New File");

	strcpy(bottom_buttons[4].name_normal,"F5-Copy");
	bottom_buttons[4].press_func_normal=activate_copy_menu;

	strcpy(bottom_buttons[5].name_normal,"F6-Ren/Move");
	bottom_buttons[5].press_func_normal=activate_move_menu;
	strcpy(bottom_buttons[5].name_shift,"F6-Rename");


	strcpy(bottom_buttons[6].name_normal,"F7-MkDir");
	strcpy(bottom_buttons[6].name_shift,"F7-Search");
	bottom_buttons[6].press_func_normal=activate_mkdir_menu;

	strcpy(bottom_buttons[7].name_normal,"F8-Delete");
	bottom_buttons[7].press_func_normal=activate_delete_menu;

	strcpy(bottom_buttons[8].name_normal,"F9-Config");
	bottom_buttons[8].press_func_normal=activate_config_menu;


	strcpy(bottom_buttons[9].name_normal,"F10-Quit");


}

