#ifndef __MENU_HANDLING_H__
#define __MENU_HANDLING_H__

#define MAX_MENUS 50

typedef struct
{
	void (*display_func)();
	void (*mouseover_func)();
	void (*click_func)();
	void (*keypress_func)();
	int x_1;
	int y_1;
	int x_2;
	int y_2;
	int opened;
	int mouse_over_element;
	char name[128];
}menu;

extern menu menus[MAX_MENUS];
extern int menus_no;

void clear_menus();
int process_keyboard_menus(Uint8 key);
int click_menus(int left_b, int right_b, int mouse_x, int mouse_y);
void display_menus();
int mouse_over_menus(int mouse_x, int mouse_y);
int add_menu(char *name,int x_1, int x_2, int y_1, int y_2, void *display_func, void *mouseover_func, void *click_func, void *keypress_func, int opened);

#endif

