#ifndef __MENUS_H__
#define __MENUS_H__


extern int mkdir_menu_id;
extern int sort_menu_id;
extern int bookmarks_menu_id;
extern int error_menu_id;
extern int copy_menu_id;
extern int copying_menu_id;
extern int overwrite_menu_id;
extern int delete_menu_id;
extern int deleting_menu_id;
extern int config_menu_id;
extern int calculating_size_menu_id;

extern int overwrite_selected_button;

#define BUTTONS_NO 10
#define BUTTONS_SPACING 4

#define SORT_MENU_ENTRIES 7

#define MAX_BOOKMARKS 30
#define BOOKMARK_MENU_ENTRIES 40

typedef struct
{
	void (*press_func_normal)();
	void (*press_func_shift)();
	char name_normal[32];
	char name_shift[32];
	int pressed;
}bottom_button;

typedef struct
{
	char name[128];
	int sort_type;
}sort_menu_entry;

//bookmark types
#define BOOKMARK_DRIVE 0
#define BOOKMARK_DIR 1
#define BOOKMARK_ADD_BOOKMARK 2

typedef struct
{
	char name[256];
	int type;
}bookmark;

typedef struct
{
	char name[256];
	int type;
}bookmark_menu_entry;

extern sort_menu_entry sort_menu_entries[SORT_MENU_ENTRIES];

extern bottom_button bottom_buttons[BUTTONS_NO];

extern bookmark bookmarks[MAX_BOOKMARKS];
extern bookmark_menu_entry bookmark_menu_entries[BOOKMARK_MENU_ENTRIES];

extern int last_bookmark;
extern int last_menu_bookmark;

extern int tooltip_x;
extern int tooltip_y;
extern char tooltip_text[500];


void pre_open_copy_menu();
void format_errno_error(char *str);
void set_error(char *main_error, char *aux_error);
void open_bookmarks_menu();
void format_chdir_error();
void draw_mkdir_menu();
void click_mkdir_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void mkdir_menu_keypresses(Uint8 ascii);
void draw_sort_menu();
void click_sort_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void mouse_over_sort_menu(int mouse_x, int mouse_y);
void draw_bookmarks_menu();
void click_bookmarks_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void mouse_over_bookmarks_menu(int mouse_x, int mouse_y);
void draw_error_menu();
void error_menu_keypresses(Uint8 ascii);
void click_error_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void draw_copy_menu();
void click_copy_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void copy_menu_keypresses(Uint8 ascii);
void draw_copying_menu();
void copying_menu_keypresses(Uint8 ascii);
void click_copying_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void draw_overwrite_menu();
void click_overwrite_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void overwrite_menu_keypresses(Uint8 ascii);
void draw_main_screen(SDL_Surface * this_screen);
int check_main_buttons(int left_b, int right_b, int mouse_x, int mouse_y);
void draw_delete_menu();
void click_delete_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void delete_menu_keypresses(Uint8 ascii);
void draw_deleting_menu();
void deleting_menu_keypresses(Uint8 ascii);
void click_deleting_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void click_config_menu(int left_b, int right_b, int mouse_x, int mouse_y);
void draw_config_menu();
void config_keypresses(Uint8 ascii);
void draw_calculating_size_menu();

void activate_delete_menu();
void activate_copy_menu();
void activate_mkdir_menu();
void activate_move_menu();
void activate_config_menu();
void pre_open_copy_menu_drag(int from_panel, int to_panel, int selected_location);

#endif

