#include "global.h"

int char_y_len=16;
int char_x_len=6;

int select_file_mode;

int dragging_files;
int drag_over_panel=-1;
int drag_selected_pos=-1;

void cancel_drag_files()
{
	dragging_files=0;
	drag_over_panel=-1;
	drag_selected_pos=-1;
	tooltip_text[0]=0;
	update_screen=1;
}

void drag_files(int left_b, int mouse_x, int mouse_y)
{
	int selected_dirs=0;
	int selected_files=0;
	int i;
	int xpanel,ypanel,collumn_length;
	int files_per_collumn;
	int y_offset,x_offset;
	int y_len;
	int x_len;

	if(!left_b)
		{
			if(drag_over_panel!=-1 && drag_selected_pos!=-1)
				{
					move_instead_of_copy=0;
					strcpy(menus[copy_menu_id].name,"Copy files");
					pre_open_copy_menu_drag(active_panel, drag_over_panel, drag_selected_pos);
				}

			cancel_drag_files();
			return;
		}

	for(i=0;i<panels[active_panel].number_of_files;i++)
	if(panels[active_panel].panel_files[i].selected)
		{
			if(panels[active_panel].panel_files[i].is_dir)
				{
	 				selected_dirs++;
				}
	 		else
	 			{
	 				selected_files++;
				}
		}

	if(selected_files || selected_dirs)
		{
			if(selected_files && !selected_dirs)
			sprintf(tooltip_text,"%i files(s)",selected_files);
			else
			if(!selected_files && selected_dirs)
			sprintf(tooltip_text,"%i directories",selected_dirs);
			else
			sprintf(tooltip_text,"%i file(s) and %i directories",selected_files,selected_dirs);
		}
	else
		{
			strcpy(tooltip_text,panels[active_panel].panel_files[panels[active_panel].panel_files_order[panels[active_panel].cursor_file]].name);
		}




	for(i=0;i<2;i++)
	if(mouse_x>panels[i].x_pos_1 && mouse_y>panels[i].y_pos_1 && mouse_x<panels[i].x_pos_2 && mouse_y<panels[i].y_pos_2)
		{
			drag_over_panel=i;
			break;
		}

	if(drag_over_panel==-1)
		{
			drag_over_panel=-1;
			drag_selected_pos=-1;
			return;//not on the panels
		}


	//select a file?
	y_len=panels[drag_over_panel].y_pos_2-panels[drag_over_panel].y_pos_1;
	x_len=panels[drag_over_panel].x_pos_2-panels[drag_over_panel].x_pos_1;
	xpanel=panels[drag_over_panel].x_pos_1;
	ypanel=panels[drag_over_panel].y_pos_1;
	collumn_length=(panels[drag_over_panel].x_pos_2-panels[drag_over_panel].x_pos_1)/panels[drag_over_panel].collumns;
	files_per_collumn=(y_len-60)/char_y_len;
	x_offset=mouse_x-xpanel;
	y_offset=mouse_y-ypanel-24;

	if(y_offset<0)
		{
			drag_over_panel=-1;
			drag_selected_pos=-1;
			return;
		}

	if(y_offset>files_per_collumn*char_y_len)
		{
			drag_over_panel=-1;
			drag_selected_pos=-1;
			return;//too far down
		}

	drag_selected_pos=(x_offset/collumn_length)*files_per_collumn+panels[drag_over_panel].start_display_file+y_offset/char_y_len;

	dragging_files=1;
	tooltip_x=mouse_x;
	tooltip_y=mouse_y+12;

}

void draw_panel(SDL_Surface * this_screen, int collumns, int which_panel, Uint8 border_color)
{
	int x, y, my_pitch;
	int i,j,k;
	int xpanel,ypanel,xlen,ylen;
	Uint8 *screen_buffer;
	int collumn_length;
	int files_per_collumn;
	int files_to_display;
	my_file *files_list=panels[which_panel].panel_files;
	int *files_order=panels[which_panel].panel_files_order;
	int cursor_file=panels[which_panel].cursor_file;
	int text_len_pixels;
	unsigned long long int free_space;
	int selected_files_no=0;
	unsigned long long int selected_files_size=0;
	char str[512];
	mode_t st_mode;
	int tmp_kb_size;

	if(!kb_size)tmp_kb_size=1024;
	else tmp_kb_size=1000;

	xpanel=panels[which_panel].x_pos_1;
	ypanel=panels[which_panel].y_pos_1;
	xlen=panels[which_panel].x_pos_2-xpanel;
	ylen=panels[which_panel].y_pos_2-ypanel;

	collumn_length=xlen/collumns;
	files_per_collumn=(ylen-60)/char_y_len;

	panels[which_panel].collumns=collumns;

	panels[which_panel].files_per_collumn=files_per_collumn;
	panels[which_panel].files_per_pannel=files_per_collumn*collumns;

	screen_buffer = (Uint8 *)this_screen->pixels;
	my_pitch = this_screen->pitch;

	if(xpanel + xlen>=my_pitch)xlen=my_pitch-xpanel-1;
	if(ypanel + ylen>=window_height)ylen=window_height-ypanel-1;


	//horizontal lines
	//upper line
	draw_line(this_screen, xpanel, ypanel, 2, xlen, border_color);

	draw_line(this_screen, xpanel, ypanel+20, 2, xlen, border_color);

	draw_line(this_screen, xpanel, ypanel+ylen-2-34, 2, xlen, border_color);

	//bottom line
	draw_line(this_screen, xpanel, ypanel+ylen-2, 2, xlen, border_color);

	//vertical lines
	//first
	draw_line(this_screen, xpanel, ypanel, ylen, 2, border_color);

	//last
	draw_line(this_screen, xpanel+xlen, ypanel, ylen, 2, border_color);

	//vertical dividers
	for(i=1;i<collumns;i++)
		{
			draw_line(this_screen, xpanel+collumn_length*i, ypanel+20, ylen-2-34-20, 2, border_color);
		}

	//see if we need to refresh the files
	if(!panels[which_panel].dir_path[0] || panels[which_panel].needs_reread)
		{
			if(!panels[which_panel].dir_path[0])getcwd(panels[which_panel].dir_path, 200);
			else
			if(chdir(panels[which_panel].dir_path)==-1)format_chdir_error();

			panels[which_panel].needs_reread=1;
		}

	if(panels[which_panel].needs_reread)
		{
			panels[which_panel].number_of_files=read_cur_dir(panels[which_panel].dir_path, files_list, files_order);
			do_files_grouping(files_list, files_order, panels[which_panel].number_of_files);

			sort_cur_dir(files_list, files_order, panels[which_panel].number_of_files, panels[which_panel].sort_type);

			//see if we need to change the cursor position to match the directory we just exited
			if(panels[which_panel].last_path[0])
			for(i=0;i<panels[which_panel].number_of_files;i++)
			if(!strcmp(panels[which_panel].last_path,files_list[panels[which_panel].panel_files_order[i]].name))
				{
					panels[which_panel].cursor_file=i;
					cursor_file=i;
				}

			panels[which_panel].needs_reread=0;
			panels[which_panel].needs_resort=0;
			panels[which_panel].start_display_file=0;//TO DO: check if the cursor is too high and adjust the starting position

			//did we request a reread of this panel from the other panel?
			if(active_panel!=which_panel)
				{
					if(chdir(panels[active_panel].dir_path)==-1)format_chdir_error();
				}
		}

	if(panels[which_panel].needs_resort)
		{
			sort_cur_dir(files_list, files_order, panels[which_panel].number_of_files, panels[which_panel].sort_type);
			panels[which_panel].needs_resort=0;
		}

	//TOP PART
	//display the cur dir
		{
			int len;
			int pixels_len=xlen-50;
			int first_char=0;

			len=strlen(panels[which_panel].dir_path);

			if(len*char_x_len>pixels_len)
			first_char=(len*char_x_len-pixels_len)/char_x_len;

			if(first_char<0)first_char=0;

			TTF_DrawText(screen, font_default,xpanel+5,ypanel+4,C_WHITE,&panels[which_panel].dir_path[first_char],pixels_len);
		}

	//display sorting 'button'
	TTF_DrawText(screen, font_default,xpanel+xlen-45,ypanel+4,C_WHITE,"[sort by]",50);

	//BOTTOM PART
	//display the file name
#ifndef WINDOWS
	if(files_list[files_order[cursor_file]].is_link)
		{
			char buf[200];
			char path[2048];
			int link_len;

			strcpy(path,panels[which_panel].dir_path);
			strcat(path,"/");
			strcat(path,files_list[files_order[cursor_file]].name);

			link_len=readlink(path,buf,150);
			if(link_len!=-1)
				{
					buf[link_len]=0;
					sprintf(str,"[%s]",buf);
				}
		}
	else
#endif
	sprintf(str,"[%s]",files_list[files_order[cursor_file]].name);
	text_len_pixels=TTF_DrawText(screen, font_default,xpanel+5,ypanel+ylen-char_y_len*2,C_SELECTED_FILE_COLOR,str,400);

	//display the size or Dir
	if(files_list[files_order[cursor_file]].is_dir)
		{
			if(files_list[files_order[cursor_file]].st_size)
			format_number(files_list[files_order[cursor_file]].st_size,str,(decimal_separator) ? '.':',');
			else
			sprintf(str,"%s","Dir");
		}
	else
		{
/*
			unsigned long long int wtf_size=0;
			wtf_size+=(unsigned int)files_list[files_order[cursor_file]].st_size;
			format_number(wtf_size,str,',');
*/
			//format_number((unsigned long long int)files_list[files_order[cursor_file]].st_size,str,(decimal_separator) ? '.':',');
			format_number(files_list[files_order[cursor_file]].st_size,str,(decimal_separator) ? '.':',');

		}

	TTF_DrawText(screen, font_default,xpanel+15+text_len_pixels,ypanel+ylen-char_y_len*2,C_GREEN,str,300);

	//print the date
	if(files_list[files_order[cursor_file]].name[0]!='.' || files_list[files_order[cursor_file]].name[1]!='.' || files_list[files_order[cursor_file]].name[2]!=0)//not for the .. dir
		{
			format_date(files_list[files_order[cursor_file]].mtime,str,date_format);
			TTF_DrawText(screen, font_default,xpanel+xlen-127,ypanel+ylen-char_y_len*2,C_GREEN,str,300);
		}

	files_to_display=panels[which_panel].number_of_files;

	//display the selected files size/no
	for(i=0;i<files_to_display;i++)
	if(files_list[i].selected)
		{
	 		selected_files_no++;
			selected_files_size+=files_list[i].st_size;
		}
	if(selected_files_no)
		{
			char str_size[24];
			format_number(selected_files_size,str_size,(decimal_separator) ? '.':',');
			sprintf(str,"%s bytes in %i files",str_size,selected_files_no);
			TTF_DrawText(screen, font_default,xpanel+xlen-180,ypanel+ylen-char_y_len-2,C_SELECTED_FILE_COLOR,str,300);
		}

	//display the left over space

	free_space=get_disk_space(panels[which_panel].dir_path);

	if(free_space>tmp_kb_size*tmp_kb_size*10)
	sprintf(str,"%u MB free on this drive",free_space/(tmp_kb_size*tmp_kb_size));
	else
	sprintf(str,"%u bytes free on this drive",(unsigned int)free_space);

	text_len_pixels=TTF_DrawText(screen, font_default,xpanel+5,ypanel+ylen-char_y_len-2,C_SELECTED_FILE_COLOR,str,300);

	//display the permissions (if not Windows)
#ifndef WINDOWS
	{
		struct passwd *pwd;
		struct group *grp;

		st_mode=files_list[files_order[cursor_file]].st_mode;

		pwd = getpwuid(files_list[files_order[cursor_file]].st_uid);
		grp = getgrgid(files_list[files_order[cursor_file]].st_gid);

		sprintf(str,"%c%c%c%c%c%c%c%c%c %s %s",(st_mode & S_IRUSR) ? 'r':'-',(st_mode & S_IWUSR) ? 'w':'-',(st_mode & S_IXUSR) ? 'x':'-',
		(st_mode & S_IRGRP) ? 'r':'-',(st_mode & S_IWGRP) ? 'w':'-',(st_mode & S_IRWXG) ? 'x':'-',
		(st_mode & S_IRWXO) ? 'r':'-',(st_mode & S_IWOTH) ? 'w':'-',(st_mode & S_IXOTH) ? 'x':'-',pwd->pw_name,grp->gr_name);
	}
#else
	{
		int file_attributes=files_list[files_order[cursor_file]].windows_attributes;

		str[0]=0;
		if(file_attributes & FILE_ATTRIBUTE_HIDDEN)strcat(str,"Hi");
		if(file_attributes & FILE_ATTRIBUTE_ARCHIVE)strcat(str,"Ah");
		if(file_attributes & FILE_ATTRIBUTE_DEVICE)strcat(str,"Dv");
		if(file_attributes & FILE_ATTRIBUTE_ENCRYPTED)strcat(str,"Ec");
		if(file_attributes & FILE_ATTRIBUTE_READONLY)strcat(str,"Ro");
		if(file_attributes & FILE_ATTRIBUTE_SYSTEM)strcat(str,"Sy");
		if(file_attributes & FILE_ATTRIBUTE_TEMPORARY)strcat(str,"Tp");
		//if(file_attributes & FILE_ATTRIBUTE_VIRTUAL)strcat(str,"Vt");


	}

#endif
	TTF_DrawText(screen, font_default,xpanel+15+text_len_pixels,ypanel+ylen-char_y_len-2,C_GREEN,str,300);

	if(files_to_display>files_per_collumn*collumns)files_to_display=files_per_collumn*collumns;

	//see if the cursor is out of range if we resize the window
	if(cursor_file>=panels[which_panel].start_display_file+files_to_display)
		{
			cursor_file=panels[which_panel].start_display_file+files_to_display-1;
			panels[which_panel].cursor_file=cursor_file;
		}

	//this can happens if we resize the window
	if(panels[which_panel].start_display_file+files_to_display>panels[which_panel].number_of_files)
	files_to_display=panels[which_panel].number_of_files-panels[which_panel].start_display_file;


	//display the file names
	j=0;
	k=0;
	for(i=panels[which_panel].start_display_file;i<panels[which_panel].start_display_file+files_to_display;i++)
		{
			Uint8 file_color=C_WHITE;
			TTF_Font *font_type;

			//display the cursor file
			if(cursor_file==i && active_panel==which_panel)
				{
					draw_line(this_screen, xpanel+k*collumn_length+3, ypanel+24+j*char_y_len, char_y_len, collumn_length-4, C_CURSOR_COLOR);
				}

			if(drag_selected_pos==i && drag_over_panel==which_panel && files_list[panels[which_panel].panel_files_order[i]].is_dir)
				{
					draw_frame(screen, xpanel+k*collumn_length+3, ypanel+24+j*char_y_len-1, collumn_length-4, char_y_len, C_WHITE, C_WHITE);
				}

			if(files_list[panels[which_panel].panel_files_order[i]].selected)file_color=C_SELECTED_FILE_COLOR;
			else
			if(files_list[panels[which_panel].panel_files_order[i]].group!=-1)file_color=files_list[panels[which_panel].panel_files_order[i]].group;

			if(files_list[panels[which_panel].panel_files_order[i]].is_dir)
				{
					if(files_list[panels[which_panel].panel_files_order[i]].is_hidden)
						{
							font_type=font_italic_bold;
							if(file_color!=C_SELECTED_FILE_COLOR)file_color=C_LIGHT_GRAY;
							TTF_DrawText(screen, font_italic_bold,xpanel+k*collumn_length+4,ypanel+24+j*char_y_len,file_color,files_list[panels[which_panel].panel_files_order[i]].name,collumn_length-4);
						}
					else
						{
							font_type=font_bold;
							TTF_DrawText(screen, font_bold,xpanel+k*collumn_length+4,ypanel+24+j*char_y_len,file_color,files_list[panels[which_panel].panel_files_order[i]].name,collumn_length-4);
						}
				}
			else
				{
					char special_file=files_list[panels[which_panel].panel_files_order[i]].is_special;
					if(special_file)
						{
							char extended_name[FILENAME_MAX+10];

							if(special_file==SPECIAL_TYPE_BLOCK_DEV)
							sprintf(extended_name,"blk dev:%s",files_list[panels[which_panel].panel_files_order[i]].name);
							else
							if(special_file==SPECIAL_TYPE_CHAR_DEV)
							sprintf(extended_name,"chr dev:%s",files_list[panels[which_panel].panel_files_order[i]].name);
							else
							if(special_file==SPECIAL_TYPE_PIPE)
							sprintf(extended_name,"pipe:%s",files_list[panels[which_panel].panel_files_order[i]].name);
							else
							if(special_file==SPECIAL_TYPE_SOCK)
							sprintf(extended_name,"sock:%s",files_list[panels[which_panel].panel_files_order[i]].name);

							font_type=font_italic;
							if(file_color!=C_SELECTED_FILE_COLOR)file_color=C_LIGHT_GRAY;
							TTF_DrawText(screen, font_italic,xpanel+k*collumn_length+4,ypanel+24+j*char_y_len,file_color,extended_name,collumn_length-4);

						}
					else
					if(files_list[panels[which_panel].panel_files_order[i]].is_hidden)
						{
							font_type=font_italic;
							if(file_color!=C_SELECTED_FILE_COLOR)file_color=C_LIGHT_GRAY;
							TTF_DrawText(screen, font_italic,xpanel+k*collumn_length+4,ypanel+24+j*char_y_len,file_color,files_list[panels[which_panel].panel_files_order[i]].name,collumn_length-4);
						}
					else
						{
							font_type=font_default;
							TTF_DrawText(screen, font_default,xpanel+k*collumn_length+4,ypanel+24+j*char_y_len,file_color,files_list[panels[which_panel].panel_files_order[i]].name,collumn_length-4);
						}
				}

#ifndef WINDOWS
			if(files_list[panels[which_panel].panel_files_order[i]].is_link)
				{
					int text_w,text_h;

					my_TTF_SizeText(font_type, files_list[panels[which_panel].panel_files_order[i]].name, &text_w, &text_h);

					if(text_w>collumn_length-4)text_w=collumn_length-4;

					if(files_list[panels[which_panel].panel_files_order[i]].is_broken)
					draw_line(screen, xpanel+k*collumn_length+4, ypanel+24+j*char_y_len+char_y_len-9, 1, text_w, file_color);
					else
					draw_line(screen, xpanel+k*collumn_length+4, ypanel+24+j*char_y_len+char_y_len-3, 1, text_w, file_color);
				}
#endif

			j++;
			if(j>=files_per_collumn)
				{
					j=0;
					k++;
				}

		}
}

//events
void activate_cur_file()
{
	my_file *files_list=panels[active_panel].panel_files;
	int *files_order=panels[active_panel].panel_files_order;
	int cursor_file=panels[active_panel].cursor_file;

	if(files_list[files_order[cursor_file]].is_dir)
		{
			//if the new directory is ".." copy the last path so we can reset the cursor to the last directory position
			if(!strcmp(files_list[files_order[cursor_file]].name,".."))
				{
					int i=0;
					int j;
					int len=strlen(panels[active_panel].dir_path);
					Uint8 cur_char;

					j=len-1;

					//separate the dir name from the rest of the path
					while(1)
						{
							cur_char=panels[active_panel].dir_path[j];

							if(!j)
								{
									if(cur_char=='\\' || cur_char=='/')j++;
									break;
								}

							if(cur_char=='\\' || cur_char=='/')
								{
									j++;//go at the beginning of the dir name
									break;
								}
							j--;
						}

					for(i=0;i<len;i++)
						{
							cur_char=panels[active_panel].dir_path[j];
							panels[active_panel].last_path[i]=cur_char;
							j++;
						}


				}
			else
				{
					panels[active_panel].last_path[0]=0;
				}

			panels[active_panel].cursor_file=0;

			if(chdir(files_list[files_order[cursor_file]].name)==-1)format_chdir_error();

			panels[active_panel].dir_path[0]=0;//force a reread/refresh
			return;
		}

#ifdef WINDOWS
	ShellExecute(NULL,NULL,files_list[files_order[cursor_file]].name,NULL,NULL,SW_SHOWDEFAULT);
#else
	{
		char str[MAX_PATH];
		if(files_list[files_order[cursor_file]].is_exe)
		sprintf(str,"./%s &",files_list[files_order[cursor_file]].name);
		else
		sprintf(str,"xdg-open %s &",files_list[files_order[cursor_file]].name);

		system(str);
	}
#endif
}

void move_cursor_up()
{
	if(panels[active_panel].cursor_file==0)return;//too up

	if(panels[active_panel].cursor_file==panels[active_panel].start_display_file)
		{
			//first position on the pannel, if this is the case advance to the previous collumn
			panels[active_panel].cursor_file--;
			panels[active_panel].start_display_file--;

			if(panels[active_panel].start_display_file<0)
			panels[active_panel].start_display_file=0;
		}
	else
	panels[active_panel].cursor_file--;

}

void move_cursor_down()
{
	if(panels[active_panel].cursor_file>=panels[active_panel].number_of_files-1)return;//too down

	if(panels[active_panel].cursor_file==panels[active_panel].start_display_file+panels[active_panel].files_per_pannel-1)
		{
			//last position on the pannel, if this is the case advance to the next collumn
			panels[active_panel].cursor_file++;
			panels[active_panel].start_display_file++;

			if(panels[active_panel].start_display_file+1>panels[active_panel].number_of_files)
			panels[active_panel].start_display_file=panels[active_panel].number_of_files-1;
		}
	else
	panels[active_panel].cursor_file++;
}

void move_cursor_right()
{

	if(panels[active_panel].cursor_file==panels[active_panel].start_display_file+panels[active_panel].files_per_pannel-1)
		{
			//last position on the pannel, if this is the case advance to the next collumn
			panels[active_panel].cursor_file+=panels[active_panel].files_per_collumn;
			panels[active_panel].start_display_file+=panels[active_panel].files_per_collumn;

			if(panels[active_panel].start_display_file+panels[active_panel].files_per_pannel>panels[active_panel].number_of_files)
			panels[active_panel].start_display_file=panels[active_panel].number_of_files-panels[active_panel].files_per_pannel;
		}
	else
		{
			panels[active_panel].cursor_file+=panels[active_panel].files_per_collumn;
			if(panels[active_panel].cursor_file>=panels[active_panel].start_display_file+panels[active_panel].files_per_pannel)
			panels[active_panel].cursor_file=panels[active_panel].start_display_file+panels[active_panel].files_per_pannel-1;
		}

	if(panels[active_panel].cursor_file>=panels[active_panel].number_of_files)panels[active_panel].cursor_file=panels[active_panel].number_of_files-1;

}

void move_cursor_left()
{

	if(panels[active_panel].cursor_file==panels[active_panel].start_display_file)
		{
			//first position on the pannel, if this is the case advance to the previous collumn
			panels[active_panel].cursor_file-=panels[active_panel].files_per_collumn;
			panels[active_panel].start_display_file-=panels[active_panel].files_per_collumn;

			if(panels[active_panel].start_display_file<0)
			panels[active_panel].start_display_file=0;
		}
	else
		{
			panels[active_panel].cursor_file-=panels[active_panel].files_per_collumn;
			if(panels[active_panel].cursor_file<=panels[active_panel].start_display_file)
			panels[active_panel].cursor_file=panels[active_panel].start_display_file;
		}

	if(panels[active_panel].cursor_file<0)panels[active_panel].cursor_file=0;

}

void move_cursor_home()
{
	panels[active_panel].cursor_file=0;
	panels[active_panel].start_display_file=0;

}

void move_cursor_end()
{
	panels[active_panel].cursor_file=panels[active_panel].number_of_files-1;

	if(panels[active_panel].number_of_files>panels[active_panel].files_per_pannel)
		{
			panels[active_panel].start_display_file=panels[active_panel].number_of_files-panels[active_panel].files_per_pannel;
		}
}

void switch_panels()
{
	if(menus[delete_menu_id].opened)return;
	if(menus[copying_menu_id].opened)return;
	if(menus[mkdir_menu_id].opened)return;
	if(menus[copy_menu_id].opened)return;

	active_panel=!active_panel;
	if(chdir(panels[active_panel].dir_path)==-1)format_chdir_error();
}

int click_on_panel(int left_b, int right_b, int mouse_x, int mouse_y)
{
	int which_panel=-1;
	int i;
	int select_file=-1;
	int xpanel,ypanel,collumn_length;
	int files_per_collumn;
	int y_offset,x_offset;
	int y_len;
	int x_len;

	for(i=0;i<2;i++)
	if(mouse_x>panels[i].x_pos_1 && mouse_y>panels[i].y_pos_1 && mouse_x<panels[i].x_pos_2 && mouse_y<panels[i].y_pos_2)
		{
			which_panel=i;
			break;
		}

	if(which_panel==-1)return 0;//not a click on the panels..

	if(long_pressed_button_l>=3 || dragging_files)
		{
			drag_files(left_b, mouse_x, mouse_y);
			return 1;
		}

	if(!left_b && !right_b)return 0;
	if(which_panel!=active_panel)switch_panels();

	//select a file?
	y_len=panels[which_panel].y_pos_2-panels[which_panel].y_pos_1;
	x_len=panels[which_panel].x_pos_2-panels[which_panel].x_pos_1;
	xpanel=panels[which_panel].x_pos_1;
	ypanel=panels[which_panel].y_pos_1;
	collumn_length=(panels[which_panel].x_pos_2-panels[which_panel].x_pos_1)/panels[which_panel].collumns;
	files_per_collumn=(y_len-60)/char_y_len;

	//click on the sort button?
	if(mouse_x>=xpanel+x_len-45 && mouse_y>=ypanel+4 && mouse_x<=xpanel+x_len-5 && mouse_y<=ypanel+20)
		{
			sort_menu_id=add_menu("Sort by",xpanel+x_len-130,xpanel+x_len-10, ypanel+25, ypanel+25+145, draw_sort_menu, mouse_over_sort_menu, click_sort_menu, NULL, 0);
			menus[sort_menu_id].opened=1;
		}

	//click on the bookmarks button?
	if(mouse_x>=xpanel+5 && mouse_y>=ypanel+4 && mouse_x<=xpanel+200 && mouse_y<=ypanel+20)
		{
			open_bookmarks_menu();
		}


	x_offset=mouse_x-xpanel;
	y_offset=mouse_y-ypanel-24;
	if(y_offset<0)return;
	if(y_offset>files_per_collumn*char_y_len)return;//too far down

	select_file=(x_offset/collumn_length)*files_per_collumn+panels[which_panel].start_display_file+y_offset/char_y_len;

	if(select_file>panels[which_panel].number_of_files)select_file=panels[which_panel].number_of_files-1;
	if(select_file<0)select_file=0;

	if(select_file==panels[which_panel].cursor_file)
		{
			if(left_b && this_left_click_time-last_left_click_time<=250)
				{
					activate_cur_file();
					//left_b=0;//sometimes it gets stuck
					last_left_click_time=0;
				}
		}
	else
	panels[which_panel].cursor_file=select_file;

	if(long_pressed_button_r==1)
		{
			select_file_mode=!panels[which_panel].panel_files[panels[which_panel].panel_files_order[select_file]].selected;
		}

	if(right_b)
		{
			char *file_name;

			file_name=panels[which_panel].panel_files[panels[which_panel].panel_files_order[select_file]].name;

			//is it the parent directory?
			if(file_name[0]!='.' || file_name[1]!='.')
				{
					if(!select_file_mode)panels[which_panel].panel_files[panels[which_panel].panel_files_order[select_file]].selected=0;
					else panels[which_panel].panel_files[panels[which_panel].panel_files_order[select_file]].selected=1;
				}
		}
}

void select_all()
{
	int i;
	int files_no;
	char *file_name;

	files_no=panels[active_panel].number_of_files;

	for(i=0;i<files_no;i++)
		{
			file_name=panels[active_panel].panel_files[i].name;
			if(file_name[0]=='.' && file_name[1]=='.')continue;

			panels[active_panel].panel_files[i].selected=!panels[active_panel].panel_files[i].selected;
		}

}

void select_cur_file()
{
	int cursor_file=panels[active_panel].cursor_file;
	char *file_name;

	file_name=panels[active_panel].panel_files[panels[active_panel].panel_files_order[cursor_file]].name;

	//is it the parent directory?
	if(file_name[0]=='.' && file_name[1]=='.')
		{
			move_cursor_down();
			return;
		}

	panels[active_panel].panel_files[panels[active_panel].panel_files_order[cursor_file]].selected=!panels[active_panel].panel_files[panels[active_panel].panel_files_order[cursor_file]].selected;
	move_cursor_down();

}

void select_deselect_file_by_string(int select,char *str)
{
	int i;
	int files_no;

	files_no=panels[active_panel].number_of_files;

	for(i=0;i<files_no;i++)
	if(!panels[active_panel].panel_files[i].is_dir)//not directories
#ifdef WINDOWS
	if(!stricmp(str,panels[active_panel].panel_files[i].ext))
#else
	if(!strcasecmp(str,panels[active_panel].panel_files[i].ext))
#endif
	panels[active_panel].panel_files[i].selected=select;
}

void select_deselect_file_by_extension(int select,int ctrl)
{
	char str[16];
	int cursor_file=panels[active_panel].cursor_file;

	if(ctrl)
		{
			strcpy(str,panels[active_panel].panel_files[panels[active_panel].panel_files_order[cursor_file]].ext);
			select_deselect_file_by_string(select,str);
		}

}

void edit_file()
{
	my_file *files_list=panels[active_panel].panel_files;
	int *files_order=panels[active_panel].panel_files_order;
	int cursor_file=panels[active_panel].cursor_file;
	char execute_command[256];

	if(files_list[files_order[cursor_file]].is_dir)return;
	//sprintf(execute_command,"\"%s\" %s",default_editor,files_list[files_order[cursor_file]].name);

#ifdef WINDOWS
	ShellExecute(NULL,NULL,default_editor,files_list[files_order[cursor_file]].name,NULL,SW_SHOWDEFAULT);
#else
	{
		char str[MAX_PATH];
		sprintf(str,"%s %s &",default_editor,files_list[files_order[cursor_file]].name);
		system(str);
	}
#endif

}

void view_file()
{
	my_file *files_list=panels[active_panel].panel_files;
	int *files_order=panels[active_panel].panel_files_order;
	int cursor_file=panels[active_panel].cursor_file;
	char execute_command[256];
	char full_path_string[MAX_PATH];

	if(files_list[files_order[cursor_file]].is_dir)
		{
			if(files_list[files_order[cursor_file]].name[0]=='.' && files_list[files_order[cursor_file]].name[1]=='.')
			return;

			strcpy(full_path_string,panels[active_panel].dir_path);
			strcat(full_path_string,"/");
			strcat(full_path_string,files_list[files_order[cursor_file]].name);

			files_size=0;
			cancel_copy=0;//this cancels the dir size too
			get_dir_size(full_path_string);
			files_list[files_order[cursor_file]].st_size=files_size;
			return;
		}

	//sprintf(execute_command,"\"%s\" %s",default_editor,files_list[files_order[cursor_file]].name);

#ifdef WINDOWS
	ShellExecute(NULL,NULL,default_viewer,files_list[files_order[cursor_file]].name,NULL,SW_SHOWDEFAULT);
#else
	{
		char str[MAX_PATH];
		sprintf(str,"%s %s &",default_viewer,files_list[files_order[cursor_file]].name);
		system(str);
	}
#endif

}

void hex_view_file()
{
	my_file *files_list=panels[active_panel].panel_files;
	int *files_order=panels[active_panel].panel_files_order;
	int cursor_file=panels[active_panel].cursor_file;
	char execute_command[256];

#ifdef WINDOWS
	ShellExecute(NULL,NULL,hex_viewer,files_list[files_order[cursor_file]].name,NULL,SW_SHOWDEFAULT);
#else
	{
		char str[MAX_PATH];
		sprintf(str,"%s %s &",hex_viewer,files_list[files_order[cursor_file]].name);
		system(str);
	}
#endif

}

