#ifndef __PANELS_H__
#define __PANELS_H__

#define MAX_DIR_PATH 512
typedef struct
{
	int type;
	int sort_type;
	int number_of_files;
	int last_refreshed;
	int needs_reread;
	int needs_resort;
	int file_names_no;
	int cursor_file;
	int start_display_file;
	int files_per_collumn;
	int files_per_pannel;
	int x_pos_1;
	int y_pos_1;
	int x_pos_2;
	int y_pos_2;
	int collumns;
	my_file panel_files[MAX_FILE_NAMES];
	int panel_files_order[MAX_FILE_NAMES];
	char dir_path[MAX_DIR_PATH];
	char last_path[MAX_DIR_PATH];

}panel;

extern panel panels[2];
extern int active_panel;

#define LEFT_PANEL 0
#define RIGHT_PANEL 1

void select_deselect_file_by_extension(int select,int ctrl);
void draw_panel(SDL_Surface * this_screen, int collumns, int which_panel, Uint8 border_color);
void activate_cur_file();
void move_cursor_up();
void move_cursor_down();
void move_cursor_right();
void move_cursor_left();
void move_cursor_home();
void move_cursor_end();
void switch_panels();
int click_on_panel(int left_b, int right_b, int mouse_x, int mouse_y);
void select_all();
void select_cur_file();
void select_deselect_file_by_string(int select,char *str);
void edit_file();
void view_file();
void hex_view_file();


#endif

